unit Drawing_unit;

{
    Vector graphical editor.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2023  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode ObjFPC}{$H+}

interface
uses Classes, Dialogs, Graphics, math;

//Точка середины отрезка
Procedure Midle_point();
//Дуга
Procedure Draw_arc(Point1,Point2 : TPoint);
//Окружность по 2 ординатам
Procedure Draw_circle_2_point(Point1,Point2 : TPoint);
//Окружность по 3 точкам (вписаная в треугольник)
Procedure Draw_circle_3_point(Point1, Point2, Point3 : TPoint);
//Вписаный многоугольник
Procedure InMultAngle(x,y : integer);
//Описаный многоугольник
Procedure OutMultAngle(x,y : integer);

implementation

uses
  SysUtils, Unit1, View, Intersection_unit, my_modify;


//Описаный многоугольник
Procedure OutMultAngle(x,y : integer);

var
   r : integer; //Радиус окружности
   n : integer; //Сколько граней

   UgolSegm : real;
   i : integer;

begin
   r := StrToInt(InputBox('Радиус окружности','Введи радиус вписаной окружности','0'));
   if r = 0 then exit;
   n := StrToInt(InputBox('Количество граней','Введи количество граней','0'));
   if n = 0 then exit;

   save_prev(); //Сохранить предыдущее состояние

   r := Round(r / (cos(DegToRad(180/n))));

   UgolSegm := 360 / n;

   for i := 0 to n-1 do
   begin
     lines[k].x1 := x+Round(r*sin(DegToRad(UgolSegm)));
     lines[k].y1 := y+Round(r*cos(DegToRad(UgolSegm)));
     //Form1.WS.Canvas.Line(x,y,x+Round(r*sin(DegToRad(UgolSegm))),y+Round(r*cos(DegToRad(UgolSegm))));
     UgolSegm += 360 / n;
     lines[k].x2 := x+Round(r*sin(DegToRad(UgolSegm)));
     lines[k].y2 := y+Round(r*cos(DegToRad(UgolSegm)));
     lines[k].col := Cvet;
     lines[k].style := LineStyle;
     lines[k].Width := LineWeight;
     k+=1;
   end;
   Clear();
end;

//Вписаный многоугольник
Procedure InMultAngle(x,y : integer);

var
   r : integer; //Радиус окружности
   n : integer; //Сколько граней

   UgolSegm : real;
   i : integer;

begin
   r := StrToInt(InputBox('Радиус окружности','Введи радиус описанной окружности','0'));
   if r = 0 then exit;
   n := StrToInt(InputBox('Количество граней','Введи количество граней','0'));
   if n = 0 then exit;

   save_prev(); //Сохранить предыдущее состояние

   UgolSegm := 360 / n;

   for i := 0 to n-1 do
   begin
     lines[k].x1 := x+Round(r*sin(DegToRad(UgolSegm)));
     lines[k].y1 := y+Round(r*cos(DegToRad(UgolSegm)));
     //Form1.WS.Canvas.Line(x,y,x+Round(r*sin(DegToRad(UgolSegm))),y+Round(r*cos(DegToRad(UgolSegm))));
     UgolSegm += 360 / n;
     lines[k].x2 := x+Round(r*sin(DegToRad(UgolSegm)));
     lines[k].y2 := y+Round(r*cos(DegToRad(UgolSegm)));
     lines[k].col := Cvet;
     lines[k].style := LineStyle;
     lines[k].Width := LineWeight;
     k+=1;
   end;
   Clear();
end;

//Точка середины отрезка
Procedure Midle_point();

var
  x10,y10,x20,y20:integer;//старые координаты
  x_ser,y_ser:integer;//точка середины

  vrem:integer;

begin
  If (Selected <> 10000) and (Select_type = 1) then
  begin
      x10:=Lines[Selected].x1;
      y10:=Lines[Selected].y1;
      x20:=Lines[Selected].x2;
      y20:=Lines[Selected].y2;

      if x10>x20 then
      begin
      vrem:=x10;
      x10:=x20;
      x20:=vrem;

      vrem:=y10;
      y10:=y20;
      y20:=vrem;
      end;

      //Найти точку середины

      If (x10<>x20) then
      begin
           x_ser:=abs((x20-x10) div 2);
           if x10<x20 then x_ser+=x10 else x_ser+=x20;
      end

      else
      begin
           x_ser:=x10;
      end;

      If (y10<>y20) then
      begin
           y_ser:=abs((y20-y10) div 2);
           if y10<y20 then y_ser+=y10 else y_ser+=y20;
      end

      else
      begin
           y_ser:=y10;
      end;

      Points[k_points].x:=x_ser;
      Points[k_points].y:=y_ser;

      k_points+=1;

      Selected:=10000;
      Clear;
  end;
  If selected=10000 then
                   Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
end;

//Нахождение центра окружности, часть которой составляет дуга
function GetCenter(Point1,point2 : TPoint; R : integer) : TPoint;

var
  x1,y1 : integer;
  x2,y2 : integer;

  L, t, xc, yc, vt: Double;
  xa, ya: Double;
  //xb, yb: Double;

begin
   x1 := Point1.X; y1:= Point1.Y;
   x2 := Point2.X; y2 := Point2.Y;

    L := sqr(x1 - x2) + sqr(y1 - y2);
    vt := sqr(2*R);

    //if (L <= vt) and ((sqrt(L)+R)>R) and ((sqrt(L)+R)>R) then
    begin
        xc := 1 / (2 * l);
        t := (l - sqr(R) + sqr(R)) * xc;
        l := sqrt(abs(((vt - l) * (l - sqr(R - R))))) * xc;
        xc := (x2 - x1) * t + x1;
        yc := (y2 - y1) * t + y1;
        t := (y2 - y1) * l;
        xa := xc + t;
        //xb := xc - t;
        t := (x1 - x2) * l;
        ya := yc + t;
        //yb := yc - t;
    end;

       Result.X := Round(xa);
       Result.Y := Round(ya);
end;

//Создание дуги
Procedure Draw_arc(Point1,Point2 : TPoint);

var
   T_c : TPoint;
   Rect : TRect;
   Rad : integer;

begin
       Rad := StrToInt(InputBox('Параметры дуги','Введи радиус','0'));
       If (Rad = 0) or
          (sqrt(Power(Point1.X-Point2.X,2))<Rad) or
          (sqrt(Power(Point1.Y-Point2.Y,2))<Rad)
          then
       begin

       end;

       T_c := GetCenter(Point(Point1.x,Point1.Y), Point(Point2.x,Point2.Y),Rad);

       Rect.Left := T_c.X-Rad;
       Rect.Right := T_c.X+Rad;
       Rect.Top := T_c.Y-Rad;
       Rect.Bottom := T_c.Y+Rad;

       //Form1.WS.canvas.Brush.Style := bsClear;
       //Form1.WS.canvas.Rectangle(Rect);

       arcs[k_arc].l_x:=Rect.Left;
       arcs[k_arc].r_x:=Rect.Right;
       arcs[k_arc].t_y:=Rect.Top;
       arcs[k_arc].b_y:=Rect.Bottom;

       arcs[k_arc].col:=Cvet;
       arcs[k_arc].style:=LineStyle;
       arcs[k_arc].Width:=LineWeight;

       arcs[k_arc].x1:=Point1.X;
       arcs[k_arc].y1:=Point1.Y;
       arcs[k_arc].x2:=Point2.X;
       arcs[k_arc].y2:=Point2.Y;

       k_arc +=1;

       Clear;
end;

//Окружность по 2 ординатам
Procedure Draw_circle_2_point(Point1,Point2 : TPoint);

var
   center : TPoint;
   rad : integer;

begin
   center.X := Round(abs(Point1.X+Point2.X) div 2);
   center.Y := Round(abs(Point1.Y+Point2.Y) div 2);
   rad := Round(sqrt(sqr(Point1.X-center.x)+sqr(Point1.Y-center.Y)));

   Circles[k_cir].x := center.X;
   Circles[k_cir].y := center.Y;
   Circles[k_cir].r := rad;
   Circles[k_cir].col := Cvet;
   Circles[k_cir].style := LineStyle;
   Circles[k_cir].Width := LineWeight;

   k_cir += 1;

   Clear;
end;

//Окружность по 3 точкам (вписаная в треугольник)
Procedure Draw_circle_3_point(Point1, Point2, Point3 : TPoint);

var
   LA, LB, LC : real;
   vrem_x, vrem_y : real;
   Center : TPoint;
   Rad : integer;
   a, b, c, p : real;

begin
    LA := sqrt(sqr(Point1.X-Point2.x)+sqr(Point1.Y-Point2.y));
    LB := sqrt(sqr(Point2.X-Point3.x)+sqr(Point2.Y-Point3.y));
    LC := sqrt(sqr(Point3.X-Point1.x)+sqr(Point3.Y-Point1.y));

    vrem_x := (LB * Point1.X + LC * Point2.X + LA * Point3.X) /
                             (LA + LB + LC);
    vrem_y := (LB * Point1.Y + LC * Point2.Y + LA * Point3.Y) /
                             (LA + LB + LC);

    //Радиус круга
    a := sqrt(sqr(vrem_x-Point2.x)+sqr(vrem_y-Point2.y));
    b := sqrt(sqr(vrem_x-Point1.x)+sqr(vrem_y-Point1.y));
    c := sqrt(sqr(Point2.x-Point1.x)+sqr(Point2.y-Point1.y));
    p := (a+b+c)/2;

    Center.X := Round(vrem_x);
    Center.Y := Round(vrem_y);
    Rad := Round((2/c)*sqrt(p * (p-a)*(p-b)*(p-c)));

    Circles[k_cir].x := center.X;
    Circles[k_cir].y := center.Y;
    Circles[k_cir].r := Rad;
    Circles[k_cir].col := Cvet;
    Circles[k_cir].style := LineStyle;
    Circles[k_cir].Width := LineWeight;

    k_cir += 1;

    Clear;
end;

end.