unit MyFunc;

{
    Vector graphical editor.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2023  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode ObjFPC}{$H+}

interface
uses SysUtils;

//заполнить массив значениями integer
procedure fill(var a : array of integer; n : integer);
//заполнить массив случайными значениями integer
procedure fill_random(var a : array of integer; n_max : integer);
//заполнить массив значениями char
procedure fill(var a : array of char; n : char);
//сортировка массива тип integer по возрастанию
procedure sort(var a : array of Integer);
//сортировка массива тип char по возрастанию
procedure sort(var a : array of char);
//реверс массива integer
procedure reverse(var a : array of Integer);
//реверс массива char
procedure reverse(var a : array of Char);
//перемешивание массива Integer
procedure shuffle(var a : array of Integer);
//перемешивание массива Char
procedure shuffle(var a : array of Char);
//Вывод массива тип Integer в строку
procedure print_ar(var a : array of Integer);
//Вывод массива тип Char в строку
procedure print_ar(var a : array of Char);
//Вывод массива тип Integer с переводом строк
procedure printLn_ar(var a : array of Integer);
//Вывод массива тип Char с переводом строк
procedure printLn_ar(var a : array of Char);
//Поиск значения в массиве Integer
function in_ar(var a : array of Integer; s:integer):integer;
//Поиск значения в массиве Char
function in_ar(var a : array of Char; s:char):integer;
//Обмен значениями двух переменных тип. integer
procedure swap (var m,n:integer);
//Обмен значениями двух переменных тип. real
procedure swap (var m,n:real);
//Обмен значениями двух переменных тип. char
procedure swap (var m,n:char);
//Поиск цифры в числе. Если не найдено, то результат -1.
function num_consist(big_num, small_num:integer):integer;
//Проверка, находится ли число в интервале
function into(value, down_lim, up_lim : integer) : boolean;
//SIN в градусах
function sinD(v : real) : real;
//COS в градусах
function cosD(v : real) : real;
//TAN в градусах
function tanD(v : real):real;
//COTANGENS в градусах
function cotD(v : real):real;

implementation

//заполнить массив значениями integer
procedure fill(var a : array of integer; n : integer);

var
  i:integer;

begin
  for i:=0 to High(a) do
	a[i] := n;
end;  

//заполнить массив случайными значениями integer
procedure fill_random(var a : array of integer; n_max : integer);

var
  i:integer;

begin
   randomize;
   for i:=0 to High(a) do
     a[i] := Random(n_max);
end;

//заполнить массив значениями char
procedure fill(var a : array of char; n : char);

var
  i:integer;

begin
  for i:=0 to High(a) do
	a[i] := n;
end; 

//сортировка по возрастанию integer
procedure sort(var a : array of Integer);

var
  i:integer;
  r:integer;
  vrem:integer;
begin
   for r:=0 to Length(a)-1 do
      for i:=0 to Length(a)-1 do
          if a[i]<a[i-1] then
          begin
               vrem:=a[i-1];
               a[i-1]:=a[i];
               a[i]:=vrem;
          end;
end;

//сортировка по возрастанию char
procedure sort(var a : array of Char);

var
  i:integer;
  r:integer;
  vrem:char;
begin
   for r:=0 to Length(a)-1 do
      for i:=0 to Length(a)-1 do
          if a[i]<a[i-1] then
          begin
               vrem:=a[i-1];
               a[i-1]:=a[i];
               a[i]:=vrem;
          end;
end;

//реверс массива Integer
procedure reverse(var a : array of Integer);

var
  i:integer;
  vrem:integer;

begin
   for i:=0 to ((Length(a)-1) div 2) do
      begin
        vrem:=a[i];
        a[i]:=a[Length(a)-1-i];
        a[Length(a)-1-i]:=vrem;
      end;
end;

//реверс массива Char
procedure reverse(var a : array of Char);

var
  i:integer;
  vrem:char;

begin
   for i:=0 to ((Length(a)-1) div 2) do
      begin
        vrem:=a[i];
        a[i]:=a[Length(a)-1-i];
        a[Length(a)-1-i]:=vrem;
      end;
end;

//перемешивание массива Integer
procedure shuffle(var a : array of Integer);

var
  i:integer;
  vrem:integer;
  i2:integer;

begin
   Randomize;

   for i:=0 to ((Length(a)-1)) do
      begin
        i2:=Random(Length(a));
        vrem:=a[i];
        a[i]:=a[i2]; a[i2]:=vrem;
      end;
end;

//перемешивание массива Char
procedure shuffle(var a : array of Char);

var
  i:integer;
  vrem:char;
  i2:integer;

begin
   Randomize;

   for i:=0 to ((Length(a)-1)) do
      begin
        i2:=Random(Length(a));
        vrem:=a[i];
        a[i]:=a[i2]; a[i2]:=vrem;
      end;
end;

//Вывод массива тип Integer в строку
procedure print_ar(var a : array of Integer);

var
  i:integer;

begin
   for i:=0 to ((Length(a)-2)) do
      begin
        write(a[i],' ');
      end;
   write(a[(Length(a)-1)]);
end;

//Вывод массива тип Char в строку
procedure print_ar(var a : array of Char);

var
  i:integer;

begin
   for i:=0 to ((Length(a)-2)) do
      begin
        write(a[i],' ');
      end;
   write(a[(Length(a)-1)]);
end;

//Вывод массива тип Integer с переводом строк
procedure printLn_ar(var a : array of Integer);

var
  i:integer;

begin
   for i:=0 to ((Length(a)-1)) do
        writeLn(a[i]);
end;

//Вывод массива тип Char с переводом строк
procedure printLn_ar(var a : array of Char);

var
  i:integer;

begin
   for i:=0 to ((Length(a)-1)) do
        writeLn(a[i]);
end;

//Поиск значения в массиве Integer
function in_ar(var a : array of Integer; s:integer):integer;

var
  i:integer;

begin
   result:=-1;
   for i:=0 to ((Length(a)-1)) do
        if a[i]=s then
        begin
        result:=i;
        break;
        end;
end;


//Поиск значения в массиве Char
function in_ar(var a : array of Char; s:char):integer;

var
  i:integer;

begin
   result:=-1;
   for i:=0 to ((Length(a)-1)) do
        if a[i]=s then
        begin
        result:=i;
        break;
        end;
end;

//Обмен значениями двух переменных тип. integer
procedure swap (var m,n:integer);
var
  z:variant;
begin
  z:=m;
  m:=n;
  n:=z;
end;

//Обмен значениями двух переменных тип. real
procedure swap (var m,n:real);
var
  z:variant;
begin
  z:=m;
  m:=n;
  n:=z;
end; 

//Обмен значениями двух переменных тип. char
procedure swap (var m,n:char);
var
  z:variant;
begin
  z:=m;
  m:=n;
  n:=z;
end;

//Поиск цифры в числе
function num_consist(big_num, small_num:integer):integer;
var
  count:integer;
begin
  result:=-1;

  for count:=1 to Length(IntToStr(big_num))-1 do
     if IntToStr(big_num)[count] = IntToStr(small_num) then
     begin
     result:=count;
     break;
     end;
end;

//Проверка, находится ли число в интервале
function into(value, down_lim, up_lim : integer) : boolean;
begin
    Result:=false;
    if (value>=down_lim) and
       (value<=up_lim) then
       Result:=true;
end;

//SIN в градусах
function sinD(v : real):real;
begin
  result := sin(v*Pi/180);
end;

//COS в градусах
function cosD(v : real):real;
begin
  result := cos(v*Pi/180);
end;

//TAN в градусах
function tanD(v : real):real;
begin
  result := sin(v*Pi/180)/cos(v*Pi/180);
end;

//COTANGENS в градусах
function cotD(v : real):real;
begin
  result := cos(v*Pi/180)/sin(v*Pi/180);
end;

end.