unit Unit1;

{
    Vector graphical editor.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2023  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Menus, ComCtrls, ClipBrd, math, Unit2, Unit3, Unit4, Unit5, Unit6,
  My_Modify, View, Intersection_unit, Load_Save, Drawing_Unit, Lineprop, Dimension, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    Cross_Point : TMenuItem;
    dim: TMenuItem;
    Dr_line_pointss: TMenuItem;
    MainMenu1: TMainMenu;
    AllKrug: TMenuItem;
    div_2: TMenuItem;
    Dr_Rect: TMenuItem;
    Copy_but: TMenuItem;
    add_back: TMenuItem;
    Clear_podl: TMenuItem;
    Help_but: TMenuItem;
    Arr_left: TMenuItem;
    Ar_up: TMenuItem;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    Dimension: TMenuItem;
    Area : TMenuItem;
    Draw_hor_napr : TMenuItem;
    Draw_vert_napr : TMenuItem;
    Draw_napr_angle : TMenuItem;
    Draw_napr_2point : TMenuItem;
    Get_Angle : TMenuItem;
    Change_line_style : TMenuItem;
    Get_Centr_Mass : TMenuItem;
    Continius_line : TMenuItem;
    Arc_button : TMenuItem;
    Draw_block : TMenuItem;
    Break_block : TMenuItem;
    Circle2Point : TMenuItem;
    Krug : TMenuItem;
    Circle_3Points : TMenuItem;
    CopyToRastrBuffer : TMenuItem;
    MenuItem3 : TMenuItem;
    InMultiAngle : TMenuItem;
    ShHelp : TMenuItem;
    OutMultiAngle : TMenuItem;
    Separator12 : TMenuItem;
    Vibor : TMenuItem;
    MenuItem6 : TMenuItem;
    Sel_all : TMenuItem;
    FrameSelect : TMenuItem;
    Vibir : TMenuItem;
    Need_intersect_point : TMenuItem;
    Separator11 : TMenuItem;
    Size_draft : TMenuItem;
    Perimetr : TMenuItem;
    Save_as_menu : TMenuItem;
    Paral_napr : TMenuItem;
    Scroll_h : TScrollBar;
    Scroll_v : TScrollBar;
    Separator10 : TMenuItem;
    Separator5 : TMenuItem;
    Separator6 : TMenuItem;
    Separator7 : TMenuItem;
    Separator8 : TMenuItem;
    Separator9 : TMenuItem;
    Shift_X : TMenuItem;
    Shift_Y : TMenuItem;
    Save_Script: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    Edit: TMenuItem;
    Re_paint: TMenuItem;
    One_to_Two: TMenuItem;
    Separator1 : TMenuItem;
    Separator2 : TMenuItem;
    Separator3 : TMenuItem;
    Separator4 : TMenuItem;
    Show_back_but: TMenuItem;
    Clear_all: TMenuItem;
    L_vector: TMenuItem;
    Delete_Obj: TMenuItem;
    Cut_but: TMenuItem;
    Arr_right: TMenuItem;
    Ar_down: TMenuItem;
    Rot_sel: TMenuItem;
    Modify: TMenuItem;
    back: TMenuItem;
    Start_timer_delay : TTimer;
    Menu_AddText: TMenuItem;
    Rectangle_coord: TMenuItem;
    Pset: TMenuItem;
    ORTO: TMenuItem;
    Show_pset: TMenuItem;
    Select_color: TMenuItem;
    Add_Vector: TMenuItem;
    Show_pointss: TMenuItem;
    S_rastr: TMenuItem;
    S_vector: TMenuItem;
    Draw_line: TMenuItem;
    Dr_line_coord: TMenuItem;
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    WS: TPaintBox;
    procedure add_backClick(Sender: TObject);
    procedure Arc_buttonClick(Sender : TObject);
    procedure AreaClick(Sender : TObject);
    procedure Arr_rightClick(Sender: TObject);
    procedure Ar_downClick(Sender: TObject);
    procedure Ar_upClick(Sender: TObject);
    procedure backClick(Sender: TObject);
    procedure Change_line_styleClick(Sender : TObject);
    procedure Circle2PointClick(Sender : TObject);
    procedure Circle_3PointsClick(Sender : TObject);
    procedure Clear_podlClick(Sender: TObject);
    procedure Continius_lineClick(Sender : TObject);
    procedure Copy_butClick(Sender: TObject);
    procedure Cross_PointClick(Sender : TObject);
    procedure Cut_butClick(Sender: TObject);
    procedure Delete_ObjClick(Sender: TObject);
    procedure DimensionClick(Sender: TObject);
    procedure Draw_blockClick(Sender : TObject);
    procedure Draw_lineClick(Sender: TObject);
    procedure Draw_napr_2pointClick(Sender : TObject);
    procedure Draw_napr_angleClick(Sender : TObject);
    procedure Draw_vert_naprClick(Sender : TObject);
    procedure Dr_line_coordClick(Sender: TObject);
    procedure Dr_RectClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormWindowStateChange(Sender : TObject);
    procedure Get_AngleClick(Sender : TObject);
    procedure Get_Centr_MassClick(Sender : TObject);
    procedure AllKrugClick(Sender: TObject);
    procedure Add_VectorClick(Sender: TObject);
    procedure Div_2Click(Sender: TObject);
    procedure Clear_allClick(Sender: TObject);
    procedure OutMultiAngleClick(Sender : TObject);
    procedure L_vectorClick(Sender: TObject);
    procedure Help_butClick(Sender: TObject);
    procedure Arr_leftClick(Sender: TObject);
    procedure Draw_hor_naprClick(Sender : TObject);
    procedure Break_blockClick(Sender : TObject);
    procedure FrameSelectClick(Sender : TObject);
    procedure CopyToRastrBufferClick(Sender : TObject);
    procedure Multy_Select_butttonClick(Sender : TObject);
    procedure InMultiAngleClick(Sender : TObject);
    procedure Paral_naprClick(Sender : TObject);
    procedure PerimetrClick(Sender : TObject);
    procedure Save_as_menuClick(Sender : TObject);
    procedure Scroll_hChange(Sender : TObject);
    procedure Scroll_vChange(Sender : TObject);
    procedure Shift_XClick(Sender : TObject);
    procedure Shift_YClick(Sender : TObject);
    procedure Menu_AddTextClick(Sender: TObject);
    procedure ModifyClick(Sender: TObject);
    procedure One_to_TwoClick(Sender: TObject);
    procedure ORTOClick(Sender: TObject);
    procedure PsetClick(Sender: TObject);
    procedure Rectangle_coordClick(Sender: TObject);
    procedure Re_paintClick(Sender: TObject);
    procedure Rot_selClick(Sender: TObject);
    procedure Select_colorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Sel_allClick(Sender: TObject);
    procedure Show_back_butClick(Sender: TObject);
    procedure Show_psetClick(Sender: TObject);
    procedure Size_draftClick(Sender : TObject);
    procedure S_rastrClick(Sender: TObject);
    procedure S_vectorClick(Sender: TObject);
    procedure Start_timer_delayTimer(Sender : TObject);
    procedure ViborClick(Sender: TObject);
    procedure WSClick(Sender : TObject);
    procedure WSMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WSMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure WSPaint(Sender: TObject);
    procedure Save_ScriptClick(Sender: TObject);
  private

  public

  end;

procedure Reset_mode;

type
  coord4 = record
    x1,y1,x2,y2 : integer;
    col:Tcolor;
    Width : byte;
    style : TPenStyle;
  end;

type
  coord2 = record
    x,y:integer;
  end;

type
  coord3 = record
    x,y,r:integer;
    col:Tcolor;
    Width : byte;
    style : TPenStyle;
  end;

type
  coord8 = record
    x1,y1,x2,y2 : integer;
    l_x,t_y,r_x,b_y : integer;
    col:Tcolor;
    Width : byte;
    style : TPenStyle;
  end;

type
   text_type = record
     x,y,h:integer;
     col:TColor;
     s:string[50];
   end;

 type
   arrow_type = record
     x,y:integer;
     t:string;
     col:Tcolor;
   end;

 type
   block_type = record
     kind : string;
     num : integer;
   end;

var
  Form1: TForm1;

  f_name:string;

  Pic:TBitmap;//Временная переменная для Bitmap картинок.

  Back_png:TPortableNetworkGraphic; //Переменная для PNG
  Save_png:TPortableNetworkGraphic; //Временная переменная для сохр.растров. PNG

  podl:boolean = false;//наличие подложки

  arr_length:integer = 10000;//Кол-во элементов

  lines: array of coord4;
  circles: array of coord3;
  arcs : array of coord8;
  points: array of coord2;
  nadp: array of text_type;
  arrow: array of arrow_type;
  blocks : array of array of block_type;

  lines_vrem: array of coord4; //Временные массивы для отмены команды
  circles_vrem: array of coord3;
  arcs_vrem : array of coord8;
  points_vrem: array of coord2;
  nadp_vrem: array of text_type;
  arrow_vrem: array of arrow_type;
  blocks_vrem : array of array of block_type;

  k:integer = 0;
  k_cir:integer = 0;
  k_arc:integer = 0;
  k_points:integer = 0;
  k_nadp:integer = 0;
  k_arrow:integer = 0;
  k_blocks : integer = 0;

  k_vrem:integer = 0; //Временные счетчики для отмены команды
  k_cir_vrem:integer = 0;
  k_arc_vrem:integer = 0;
  k_points_vrem:integer = 0;
  k_nadp_vrem:integer = 0;
  k_arrow_vrem:integer = 0;
  k_blocks_vrem : integer = 0;

  stad : boolean = false;
  stad_cir : boolean = false;//стадия рисования окружности
  stad_cir3 : byte = 0;//стадия рисования окружности по 3 точкам
  stad_copy : boolean =false;

  contin_line : boolean = true; //Продолжать ли каждый раз линию
  last_point : TPoint;

  cross:boolean = false;

  vr1,vr2:real;

  selected:integer = 10000;
  select_type:integer;
  copy_mode:boolean = false;
  cut_mode:boolean = false;

  modyfy:integer;

  Cvet:TColor;

  x_cross:real;
  y_cross:integer;

  x_copy,y_copy:integer;
  delta_x,delta_y:integer;
  delta_x_copy,delta_y_copy:integer;

  P_show:boolean = true;
  orto_graph:boolean = false;

  select_mode:boolean = false; //Режим выделения по умолчанию
  multy_select_mode:boolean = false; //Режим множественного выделения
  FrameSelect_mode:boolean = false; //Режим выбора рамкой

  drag_point_mode:boolean = false;//Режим перемещения за ключевые точки

  draw_line_mode:boolean = false;
  draw_line_coord_mode:boolean = false;
  draw_circle_mode:boolean = false;
  draw_circle2point_mode:boolean = false;
  draw_circle3points_mode:boolean = false; //Окружность, вписанная в треугольник
  draw_arc_mode:boolean = false;
  draw_points_mode:boolean = false;
  draw_rectangle_mode:boolean = false;
  Draw_MultiAngleMode : boolean = false;//Вписаный многоугольник
  Draw_MultiAngleOutMode : boolean = false;//Описанный многоугольник
  text_input_mode:boolean = false;
  draw_arrow_mode:boolean = false; //Режим рисования стрелок

  Hor_napr_mode : boolean = false;   //Горизонтальный луч
  Vert_napr_mode : boolean = false; //Вертикальный луч
  Angle_napr_mode : boolean = false; //Луч под углом
  Two_point_napr_mode : boolean = false; //Луч через 2 точки
  Par_shift_mode : boolean = false; //Параллельная прямая

  get_dim_mode:boolean = false;//Режим измерения
  get_angle_mode : boolean = false; //Режим измерения углов
  get_centr_mass_mode : boolean = false;//Находение центра тяжести
  get_perimetr_mode : boolean = false;//Подсчет периметра
  get_area_mode : boolean = false; //Измерение площади с обходом точек

  RotMode : boolean = false;//Режим поворота объектов

  rect_mode:boolean = false;
  x_rect,y_rect:integer;

  loc:string;//путь к файлу подложки

  arrow_kind:string;

  start_prog:boolean = true;//для белой канвы WS
  Show_back:boolean = true; //Показывать подложку

  stad_dim:boolean = false;//№ точки при измерении расстояния
  x1_dim,x2_dim,y1_dim,y2_dim:integer; //Координаты измерения
  dim_val:real; //Измеренное число

  d_length:integer;//Относительный размер для линии или окружности
  x_glob,y_glob:integer;//Координаты указателя мыши

  //stad_cir:boolean; //стадия рисования окружности

  point_list : array of TPoint; //Массив точек для вычисления площади

  sel_1, sel_2 : integer;

  Two_point_ar : array of TPoint;
  Free_point_ar : array of TPoint;

  LineStyle : TPenStyle = psSolid;
  LineWeight : byte = 1;

  multy_selected_line : array of integer;
  multy_selected_circle : array of integer;
  multy_selected_arcs : array of integer;
  multy_selected_point : array of integer;
  multy_selected_text : array of integer;
  multy_selected_arrow : array of integer;

  //Для рисования дуги
  Point1, Point2, Point3 : TPoint;

  Drag_Point : TPoint; //Точка для перемещения
  Drag_selected : integer; //Номер объекта для перетаскивания за точки


  Screen_x : integer = 0;//Сдвиг рабочего поля
  Screen_y : integer = 0;
  World_size : integer = 4000;

  imgTemp : TPortableNetworkGraphic;

implementation

{$R *.lfm}

{ TForm1 }

procedure Reset_mode;//Отключить все режимы
begin
     selected := 10000;

     select_mode := false; //Режим выделения по умолчанию
     multy_select_mode := false; //Режим множеств. выделения
     FrameSelect_mode := false; //Режим выбора рамкой

     stad := false;
     stad_cir := false;
     stad_copy := false;
     stad_dim := false;

     if (draw_line_mode) and
        (stad) then
        begin
             lines[k].x1:=0;
             lines[k].y1:=0;
        end;

     draw_line_mode := false;
     draw_line_coord_mode := false;
     draw_rectangle_mode := false;
     Draw_MultiAngleMode := false;//Описанный многоугольник
     Draw_MultiAngleOutMode := false;//Описанный многоугольник

     draw_circle_mode := false;
     draw_circle2point_mode := false;
     draw_circle3points_mode := false; //Окружность, вписанная в треугольник
     draw_arc_mode := false;

     draw_points_mode := false;

     text_input_mode := false;
     draw_arrow_mode := false; //Режим рисования стрелок

     get_dim_mode := false;//Режим измерения
     get_area_mode := false;
     get_angle_mode := false; //Режим измерения углов
     get_centr_mass_mode := false; //Режим нахождения центра тяжести
     get_perimetr_mode := false;   //Режим нахождения периметра

     RotMode := false;//Режим поворота объектов

     Hor_napr_mode := false;   //Горизонтальный луч
     Vert_napr_mode := false; //Вертикальный луч
     Angle_napr_mode := false; //Луч под углом
     Two_point_napr_mode := false; //Прямая через 2 точки
     Par_shift_mode := false;//Параллельная прямая

     drag_point_mode := true;//Режим перемещения за ключевые точки

     last_point.X := -1;   //Точка для непрерывного ввода линии
     last_point.Y := -1;

     point1.X := -1;   //Точка для рисования дуги
     point1.Y := -1;

     Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
     Form1.StatusBar1.Panels.Items[3].Text:='S=';

     setLength(multy_selected_line,0);
     setLength(multy_selected_circle,0);
     setLength(multy_selected_arcs,0);
     setLength(multy_selected_point,0);
     setLength(multy_selected_text,0);
     setLength(multy_selected_arrow,0);
end;

procedure BreakOperation;//Прервать текущую операцию
begin
   if (draw_line_mode) and
         (last_point.X <> -1) and
         (last_point.Y <> -1) then
         begin
            last_point.X := -1;
            last_point.Y := -1;
            Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
            Clear;
            exit;
         end;

      if (draw_line_mode) and
        (stad) then
        begin
             lines[k].x1:=0;
             lines[k].y1:=0;
        end;

      if (draw_circle_mode) and
         (stad_cir) then
        begin
            circles[k_cir].x := -1;
            circles[k_cir].y := -1;
        end;


      selected := 10000;
      setLength(multy_selected_line,0);
      setLength(multy_selected_circle,0);
      setLength(multy_selected_arcs,0);
      setLength(multy_selected_point,0);
      setLength(multy_selected_text,0);
      setLength(multy_selected_arrow,0);

      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
      Form1.StatusBar1.Panels.Items[3].Text:='S=';

      Clear;
      Reset_mode;
end;

procedure TForm1.WSMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
  S_area : real = 0;
  i : byte;
  vrem_pen_color : TColor;
  vrem_brush_color : TColor;

  vrem : string = '';
  vrem_angle : real = 0;

  x_cross_1, x_cross_2, y_cross_1, y_cross_2 : integer;
  k_alpha : real;

  koef, beta : real; //для наклонной направляющей

  shift_vrem : string;
  shift_size : real = 0;
  angle_line : real = 0;

  count : integer;

begin
   //Отменить операцию//////////////////////////////////////////////////////
   if button = mbRight then
   begin
      BreakOperation;
      exit;
   end;

   X:=X-Screen_x;
   Y:=Y-Screen_y;

   //Поворот вокруг выбраной точки//////////////////////////////////////////
   if (RotMode) then
   begin
      FrameSelect_mode := false;
      RotMode := false;
      Rotate(x,y);
      Reset_mode();
      exit;
   end;

   //Вписаный многоугольник//////////////////////////////////////////////////
   If (Draw_MultiAngleMode) then
   begin
       InMultAngle(x,y);
   end;

   //Описаный многоугольник///////////////////////////////////////////////////
   If (Draw_MultiAngleOutMode) then
   begin
       OutMultAngle(x,y);
   end;

   //Выбор рамкой//////////////////////////////////////////////////////////////
   if (FrameSelect_mode) then
   begin
     if (point1.X <> -1) and
        (point1.Y <> -1) then
         begin
             setLength(multy_selected_line,0);
             setLength(multy_selected_circle,0);
             setLength(multy_selected_arcs,0);
             setLength(multy_selected_point,0);
             setLength(multy_selected_text,0);
             setLength(multy_selected_arrow,0);

             //Ws.Canvas.Rectangle(point1.X,point1.Y,X,Y);
             SelectByFrame(point1.X,point1.Y,X,Y);
         end
     else
         begin
             point1.X := X;
             point1.Y := Y;
             Clear;
             exit;
         end;
   end;

   //Окружность по 3 точкам////////////////////////////////////////////////////
   If (draw_circle3points_mode) then
      begin
           save_prev();

           near_points(x,y,4);
           if (stad_cir3 = 0)  then
           begin
              point1.X := X;   //Ввод первой ординаты
              point1.Y := Y;
              Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую точку пересчения';
              stad_cir3 := 1;
              exit;
           end;
           if (stad_cir3 = 1)  then
           begin
              point2.X := X;   //Ввод первой ординаты
              point2.Y := Y;
              Form1.StatusBar1.Panels.Items[0].Text:='Укажи третью точку пересечения';
              stad_cir3 := 2;
              exit;
           end;

           point3.X := X;    //Ввод третьей точки и отрисовка
           point3.Y := Y;

           Draw_circle_3_point(Point1, Point2, Point3);
           stad_cir3 := 0;
           point1.X := -1; point1.Y := -1;
           point2.X := -1; point2.Y := -1;
           point3.X := -1; point3.Y := -1;
           Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку пересечения';
      end;

   //Пермещение объекта//////////////////////////////////////////////////////////
   If (drag_point_mode) and
      not (Par_shift_mode) and
      not (Two_point_napr_mode) and
      not (cut_mode) and
      not (copy_mode) and
      not (get_centr_mass_mode)
      then //Если включен режим перетаскивания
   begin                     //то установить новые координаты объекта
      near_points(x,y,10);
      drag_point_mode:=false;
      //Reset_mode;
      Drag_selected:=-1;
      //Selected := 10000;
   end;

   if (selected<>10000) and
      not (Par_shift_mode) and
      not (Two_point_napr_mode) and
      not (cut_mode) and
      not (copy_mode)
      then  //Включить захват точки для перетаскивания
   begin
      save_prev();
      near_points(x,y,10);
      If (select_type = 1) or
         (select_type = 2) then Drag_by_point(x,y);
   end;

   //Рисование окружности по 2 ординатам/////////////////////////////////
   if (draw_circle2point_mode) then
   begin
       save_prev();

       near_points(x,y,4);
       if (point1.X = -1) and
          (point1.Y = -1) then
       begin
          point1.X := X;   //Ввод первой ординаты
          point1.Y := Y;
          Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую ординату';
          stad_cir := true;
          exit;
       end;

       point2.X := X;    //Ввод второй ординаты и отрисовка
       point2.Y := Y;

       Draw_circle_2_point(Point1, Point2);
       stad_cir := false;
       point1.X := -1; point1.Y := -1;
       Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую ординату';
   end;

   //Рисование дуги//////////////////////////////////////////////////////
   if (draw_arc_mode) then
   begin
       save_prev();

       near_points(x,y,4);
       if (point1.X = -1) and
          (point1.Y = -1) then
       begin
          point1.X := X;   //Ввод первой точки дуги
          point1.Y := Y;
          Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую точку';
          exit;
       end;

       point2.X := X;    //Ввод второй точки и рисование дуги
       point2.Y := Y;

       Draw_arc(Point1, Point2);
       point1.X := -1; point1.Y := -1;
       Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
   end;

   ////Подсчет периметра/////////////////////////////////////////////////////
   if (get_perimetr_mode) then
   begin
      showmessage('Длина периметра равна ' + L_contur(x, y).toString);
      clear;
   end;
   /////////////////////////////////////////////////////////////////////////

   ////Подсчет центра тяжести///////////////////////////////////////////////
   if (get_centr_mass_mode) then //Нахождение центра тяжести
   begin
         Coord_CentrT(x,y);

         Reset_mode;
         Clear;
   end;

   //Измерение угла/////////////////////////////////////////////////////////
   if (get_angle_mode) then
   begin
      GetAngle(x,y);
   end;

   // Параллельная прямая///////////////////////////////////////////////////
   If (Par_shift_mode) then
   begin
       save_prev();

       if (lines[selected].x1<>lines[selected].x2) then
          angle_line :=  ArcTan((lines[selected].y1-lines[selected].y2)/(lines[selected].x1-lines[selected].x2))
       else angle_line:=DegToRad(-90);
       angle_line := angle_line+DegToRad(90);


       shift_vrem := InputBox('Размер сдвига','Укажи размер сдвига (+ вправо и вниз)','');
       if shift_vrem<>'' then
       begin
           shift_size := StrToFloat(shift_vrem);
       end;

       Lines[k].x1 := Round(Lines[Selected].x1+shift_size*cos(angle_line));
       Lines[k].y1 := Round(Lines[Selected].y1+shift_size*sin(angle_line));
       Lines[k].x2 := Round(Lines[Selected].x2+shift_size*cos(angle_line));
       Lines[k].y2 := Round(Lines[Selected].y2+shift_size*sin(angle_line));

       k+=1;

       clear;
       reset_mode;
       exit;
   end;

   //Направляющая через 2 точки////////////////////////////////////////////////
   If (Two_point_napr_mode) then
   begin
      save_prev();

      near_points(x,y,4);
      If Length(Two_point_ar)<>2 then
      begin
          SetLength(Two_point_ar,2);
          Two_point_ar[0].X := X;
          Two_point_ar[0].Y := Y;
      end
      else
      begin
          Two_point_ar[1].X := X;
          Two_point_ar[1].Y := Y;

          if (Two_point_ar[0].X = Two_point_ar[1].X) then //вертикальная линия
          begin
             Lines[k].x1 := Two_point_ar[0].X;
             Lines[k].x2 := Two_point_ar[0].X;
             Lines[k].y1 := 0;
             Lines[k].y2 := World_size;
             lines[k].col := clPurple;

              If Need_intersect_point.Checked then
              begin
                  //WS.Canvas.Lock();
                  //проверка пересечения линий
                  prov_intersect();
                  //проверка пересечения с окружностью
                  intersection_line_circ(k);
                  //WS.Canvas.UnLock();
              end;

              k+=1;

              clear;
              SetLength(Two_point_ar,0);

              exit;
          end;

          koef := (Two_point_ar[0].Y-Two_point_ar[1].Y)/
                  (Two_point_ar[0].X-Two_point_ar[1].X);
          beta := Two_point_ar[1].Y-koef*Two_point_ar[1].X;

          lines[k].x1 :=0;
          lines[k].y1 := Round(koef*lines[k].x1+beta);
          lines[k].x2 :=World_size;
          lines[k].y2 := Round(koef*lines[k].x2+beta);

          if lines[k].y1<0 then
          begin
             lines[k].y1 := 0;
             lines[k].x1 := Round((lines[k].y1-beta)/koef);
          end;
          if lines[k].y1>World_size then
          begin
             lines[k].y1 := World_size;
             lines[k].x1 := Round((lines[k].y1-beta)/koef);
          end;
          if lines[k].x1<0 then
          begin
             lines[k].x1 := 0;
             lines[k].y1 := Round(koef*lines[k].x1+beta);
          end;
          if lines[k].x1>World_size then
          begin
             lines[k].x1 := World_size;
             lines[k].y1 := Round(koef*lines[k].x1+beta);
          end;
          if lines[k].y2<0 then
          begin
             lines[k].y2 := 0;
             lines[k].x2 := Round((lines[k].y2-beta)/koef);
          end;
          if lines[k].y2>World_size then
          begin
             lines[k].y2 := World_size ;
             lines[k].x2 := Round((lines[k].y2-beta)/koef);
          end;
          if lines[k].x2<0 then
          begin
             lines[k].x2 := 0;
             lines[k].y2 := Round(koef*lines[k].x2+beta);
          end;
          if lines[k].x2>World_size then
          begin
             lines[k].x2 := World_size;
             lines[k].y2 := Round(koef*lines[k].x2+beta);
          end;

          lines[k].col := clPurple;

          If Need_intersect_point.Checked then
          begin
              //WS.Canvas.Lock();
              //проверка пересечения линий
              prov_intersect();
              //проверка пересечения с окружностью
              intersection_line_circ(k);
              //WS.Canvas.UnLock();
          end;

          k+=1;

          clear;
          SetLength(Two_point_ar,0);
      end;
   end;

   //Горизонтальная направляющая///////////////////////////////////////////////
   If (Hor_napr_mode) then
   begin
      save_prev();

      near_points(x,y,4);

      lines[k].x1:=0;
      lines[k].y1:=Y;
      lines[k].x2:=World_size;
      lines[k].y2:=Y;
      lines[k].col:=clPurple;

       If Need_intersect_point.Checked then
       begin
          //WS.Canvas.Lock();
          //проверка пересечения линий
          prov_intersect();
          //проверка пересечения с окружностью
          intersection_line_circ(k);
          //WS.Canvas.UnLock();
       end;

      k+=1;

      clear;
   end;

   //Вертикальная направляющая////////////////////////////////////////////////
   If (Vert_napr_mode) then
   begin
      save_prev();

      near_points(x,y,4);

      lines[k].x1:=X;
      lines[k].y1:=0;
      lines[k].x2:=X;
      lines[k].y2:=World_size;
      lines[k].col:=clPurple;

       If Need_intersect_point.Checked then
       begin
          //WS.Canvas.Lock();
          //проверка пересечения линий
          prov_intersect();
          //проверка пересечения с окружностью
          intersection_line_circ(k);
          //WS.Canvas.UnLock();
       end;

      k+=1;

      clear;
   end;

   //Направляющая под углом///////////////////////////////////////////////////
   If (Angle_napr_mode) then
   begin
        save_prev();

        while (vrem='') do
        begin
          vrem := InputBox('Угол наклона прямой','Введи угол (против часовой стрелки)','');
          if (vrem = '') then
          begin
               ShowMessage('Некорректный угол');
               exit;
          end;

          if (StrToFloat(vrem)<-360) or
             (StrToFloat(vrem)>360) then ShowMessage('Некорректный угол');
        end;

      vrem_angle:=-StrToFloat(vrem);
      k_alpha := tan(DegToRad(vrem_angle));

      near_points(x,y,4);

      x_cross_1 := 0;
      if (vrem_angle <> -90) and
         (vrem_angle <> 90) then
         y_cross_1 := Round(k_alpha*x_cross_1-k_alpha*x+y)
      else
        begin
          y_cross_1 := 0;
          x_cross_1:=x;
        end;

      x_cross_2 := World_size;
      if (vrem_angle <> -90) and
         (vrem_angle <> 90) then
         y_cross_2 := Round(k_alpha*x_cross_2-k_alpha*x+y)
      else
        begin
             y_cross_2 := World_size;
             x_cross_2:=x;
        end;

      lines[k].x1:=X_cross_1;
      lines[k].y1:=Y_cross_1;

      lines[k].x2:=X_cross_2;
      lines[k].y2:=y_cross_2;
      lines[k].col:=clPurple;

      If Need_intersect_point.Checked then
      begin
          //WS.Canvas.Lock();
          //проверка пересечения линий
          prov_intersect();
          //проверка пересечения с окружностью
          intersection_line_circ(k);
          //WS.Canvas.UnLock();
      end;

      k+=1;

      clear;
   end;

   //Вычисление площади фигуры/////////////////////////////////////////////////
   If (get_area_mode) then
   begin
      near_points(x,y,4);

      SetLength(point_list,Length(Point_List)+1);
      point_list[High(point_list)].X:=x+screen_x;
      point_list[High(point_list)].y:=y+screen_y;

      If (Length(point_list) > 2) then
      begin
         for i := 0 to High(point_list)-1 do
         S_area := (S_area+point_list[i].X*point_list[i+1].y-point_list[i+1].X*point_list[i].y);

         S_area := S_area + point_list[High(point_list)].X*point_list[0].y-point_list[0].X*point_list[High(point_list)].y;

         S_area := abs(S_area/2);

         clear();
         vrem_pen_color := WS.Canvas.Pen.Color;
         vrem_brush_color := WS.Canvas.Brush.Color;
         WS.Canvas.Pen.Color:=clPurple;
         WS.Canvas.Brush.Style := bsCross;
         WS.Canvas.Brush.Color := clPurple;
         WS.Canvas.Polygon(point_list);
         WS.Canvas.Pen.Color := vrem_pen_color;
         WS.Canvas.Brush.Color := vrem_brush_color;
         WS.Canvas.Brush.Style := bsClear;
      end;

      StatusBar1.Panels.Items[3].Text:='S='+FloatToStr(S_area);
   end;

   //Рисовать прямоугольник////////////////////////////////////////////////////
   If (draw_rectangle_mode = true) and not (Select_mode) then
   begin
       near_points(x,y,4);

       //1 координата
        if stad=false then
        begin
          Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую точку';

          x_rect := x; y_rect := y;
          stad:=true;

          X := x + Screen_x;
          Y := y + Screen_y;
          Form1.WS.Canvas.Pen.Color:=clRed;
          Form1.WS.Canvas.Ellipse(x-5,y+5,x+5,y-5);
          Form1.WS.Canvas.Pen.Color:=clBlack;
        end
        else    //2 координата
        begin
          save_prev(); //Сохранить предыдущее состояние

          lines[k].x1:=x_rect;
          lines[k].y1:=y_rect;
          lines[k].x2:=x;
          lines[k].y2:=y_rect;
          lines[k].col:=Cvet;
          lines[k].Width:=LineWeight;
          lines[k].style:=LineStyle;

          If Need_intersect_point.Checked then
          begin
              //WS.Canvas.Lock();
              //проверка пересечения линий
              prov_intersect();
              //проверка пересечения с окружностью
              intersection_line_circ(k);
              //WS.Canvas.UnLock();
          end;

          k+=1;

          lines[k].x1:=x;
          lines[k].y1:=y_rect;
          lines[k].x2:=x;
          lines[k].y2:=y;
          lines[k].col:=Cvet;
          lines[k].Width:=LineWeight;
          lines[k].style:=LineStyle;

          If Need_intersect_point.Checked then
          begin
              //WS.Canvas.Lock();
              //проверка пересечения линий
              prov_intersect();
              //проверка пересечения с окружностью
              intersection_line_circ(k);
              //WS.Canvas.UnLock();
          end;

          k+=1;

          lines[k].x1:=x;
          lines[k].y1:=y;
          lines[k].x2:=x_rect;
          lines[k].y2:=y;
          lines[k].col:=Cvet;
          lines[k].Width:=LineWeight;
          lines[k].style:=LineStyle;

          If Need_intersect_point.Checked then
          begin
              //WS.Canvas.Lock();
              //проверка пересечения линий
              prov_intersect();
              //проверка пересечения с окружностью
              intersection_line_circ(k);
              //SendMessage(Form1.Handle, WM_SETREDRAW, 1, 0)
          end;

          k+=1;

          lines[k].x1:=x_rect;
          lines[k].y1:=y;
          lines[k].x2:=x_rect;
          lines[k].y2:=y_rect;
          lines[k].col:=Cvet;
          lines[k].Width:=LineWeight;
          lines[k].style:=LineStyle;

          If Need_intersect_point.Checked then
          begin
              //WS.Canvas.Lock();
              //проверка пересечения линий
              prov_intersect();
              //проверка пересечения с окружностью
              intersection_line_circ(k);
              //WS.Canvas.UnLock();
          end;

          k+=1;

          stad:=false;

          Clear();//Очистка формы
          Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
        end;
   end;

   //Рисовать линию////////////////////////////////////////////////////////////
   If (Draw_line_mode = true) and not (Select_mode) then
   begin
        near_points(x,y,4);

        if (last_point.X<>-1) and
           (last_point.Y<>-1) and
           contin_line   then
           begin
              save_prev(); //Сохранить предыдущее состояние

              Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую точку';

               lines[k].x1:=last_point.X;lines[k].y1:=last_point.Y;
               stad:=true;
           end;

        //1 координата
        if stad=false then
        begin
          save_prev(); //Сохранить предыдущее состояние

          Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую точку';

          lines[k].x1:=x; lines[k].y1:=y;
          stad:=true;

          Form1.WS.Canvas.Pen.Color:=clRed;

          x := x + screen_x;
          y := y + screen_y;

          WS.Canvas.Ellipse(x-5,y+5,x+5,y-5);
          Form1.WS.Canvas.Pen.Color:=clBlack;
        end
        //2 координата
        else
        begin
          if (Orto_graph = true) then
          begin
            //if abs(x-Lines[k].x1)<20 then x:=Lines[k].x1;
            //if abs(y-Lines[k].y1)<20 then y:=Lines[k].y1;
            if abs(x-Lines[k].x1)<abs(y-Lines[k].y1) then x:=Lines[k].x1
            else y:=Lines[k].y1; //Совсем ОРТО
          end;

          lines[k].x2:=x;lines[k].y2:=y;
          lines[k].col:=Cvet;
          lines[k].Width := LineWeight;
          lines[k].style := LineStyle;

          stad:=false;

          If Need_intersect_point.Checked then
          begin
              //WS.Canvas.Lock();
              //проверка пересечения линий
              prov_intersect();
              //проверка пересечения с окружностью
              intersection_line_circ(k);
              //WS.Canvas.UnLock();
          end;

          Clear();//Очистка формы

           k+=1;

           last_point.X := X;
           last_point.Y := Y;

           if (lines[k-1].x1 = lines[k-1].x2) and  //Линия нулевой длины
              (lines[k-1].y1 = lines[k-1].y2) then //удаляется из массива
              begin
                 k-=1;
                 delete(lines,k,1);
                 setlength(lines,arr_length);
              end;

           if contin_line then
              Form1.StatusBar1.Panels.Items[0].Text:='Укажи следующую точку'
           else
               Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
        end;
    end;

  //Рисовать круг/////////////////////////////////////////////////////////////
  if (Draw_Circle_mode = true) and not (Select_mode)  then
   begin
          save_prev(); //Сохранить предыдущее состояние

          If stad_cir=false then //1 координата
          begin
              near_points(x,y,4);

              Form1.WS.Canvas.Pen.Color:=clRed;
              Circles[k_cir].x:=x; Circles[k_cir].y:=y;
              Circles[k_cir].col:=Cvet;
              Form1.WS.Canvas.Pen.Color:=clBlack;

              x := x + screen_x;
              y := y + screen_y;

              WS.Canvas.Ellipse(x-5,y+5,x+5,y-5);

              stad_cir:=true;
          end
          else   //2 координата
          begin
               near_points(x,y,4);

               Circles[k_cir].r:=Round(sqrt(Power((Circles[k_cir].x-x),2)+
                                      Power((Circles[k_cir].y-y),2)));
               Circles[k_cir].Width:=LineWeight;
               Circles[k_cir].style:=LineStyle;

               stad_cir:=false;

               //Отрисовка ординат
               //1
               //points[k_points].x:=Circles[k_cir].x;
               //points[k_points].y:=Circles[k_cir].y-Circles[k_cir].r;
               ////2
               //points[k_points+1].x:=Circles[k_cir].x;
               //points[k_points+1].y:=Circles[k_cir].y+Circles[k_cir].r;
               ////3
               //points[k_points+2].x:=Circles[k_cir].x-Circles[k_cir].r;
               //points[k_points+2].y:=Circles[k_cir].y;
               ////4
               //points[k_points+3].x:=Circles[k_cir].x+Circles[k_cir].r;
               //points[k_points+3].y:=Circles[k_cir].y;
               //Центр
               //points[k_points+4].x:=Circles[k_cir].x;
               //points[k_points+4].y:=Circles[k_cir].y;


               //k_points+=5;
               k_cir+=1;

               If Need_intersect_point.Checked then
               begin
                   //WS.Canvas.Lock();
                   intersection_circ_line(k_cir-1);
                   intersect_2_cir(Circles[k_cir-1].x, Circles[k_cir-1].y,
                   Circles[k_cir-1].r);
                   //WS.Canvas.UnLock();
               end;

               Clear();//Очистка формы
          end;
   end;

  //Добавить текст////////////////////////////////////////////////////////////
  If (Text_input_mode = true) and not (Select_mode) then
   begin
        save_prev(); //Сохранить предыдущее состояние

        Unit4.x_get:=x;
        Unit4.y_get:=y;
        Form4.Text_source.Text:='';
        Form4.Text_Size.ItemIndex:=0;
        Form4.ShowModal;

        Clear();
        Text_input_mode := false;
   end;

  //Выделить//////////////////////////////////////////////////////////////////
  if (Select_mode=true) then
   begin
        Clear();
        selected:=Select(x,y);
        exit;
   end;

   //Выделить  несколько/////////////////////////////////////////////////////
   if (multy_select_mode) then
   begin
        //Clear();
        selected:=Select(x,y);

        case select_type of
          1:   begin
                 setLength(multy_selected_line,Length(multy_selected_line)+1);
                 multy_selected_line[High(multy_selected_line)] := selected;
               end;
          2:   begin
                 setLength(multy_selected_circle,Length(multy_selected_circle)+1);
                 multy_selected_circle[High(multy_selected_circle)] := selected;
               end;
          3:   begin
                 setLength(multy_selected_point,Length(multy_selected_point)+1);
                 multy_selected_point[High(multy_selected_point)] := selected;
               end;
          4:   begin
                 setLength(multy_selected_text,Length(multy_selected_text)+1);
                 multy_selected_text[High(multy_selected_text)] := selected;
               end;
          5:   begin
                 setLength(multy_selected_arrow,Length(multy_selected_arrow)+1);
                 multy_selected_arrow[High(multy_selected_arrow)] := selected;
               end;
          6:   begin
                 setLength(multy_selected_arcs,Length(multy_selected_arcs)+1);
                 multy_selected_arcs[High(multy_selected_arcs)] := selected;
               end;
        end;
        exit;
   end;

   //Переместить///////////////////////////////////////////////////////////////
   if (cut_mode = true) then
   begin
       near_points(x,y,4);

       if (stad_copy = false) then
       begin
            x_copy:=x; y_copy:=y;
            stad_copy:=true;
            Form1.StatusBar1.Panels.Items[0].Text:='Куда переместить?';
       end
       else
       begin
            delta_x:=x-x_copy;
            delta_y:=y-y_copy;
           ///Перестановка

           //Мультивыбор////////////////////////////////////////////////
           if (Length(multy_selected_line)<>0) or
              (Length(multy_selected_circle)<>0) or
              (Length(multy_selected_arcs)<>0) or
              (Length(multy_selected_point)<>0) or
              (Length(multy_selected_text)<>0) or
              (Length(multy_selected_arrow)<>0) then
           begin
              for count := 0 to High(multy_selected_line) do
              begin
                 Lines[multy_selected_line[count]].x1+=delta_x;
                 Lines[multy_selected_line[count]].x2+=delta_x;
                 Lines[multy_selected_line[count]].y1+=delta_y;
                 Lines[multy_selected_line[count]].y2+=delta_y;
              end;
              for count := 0 to High(multy_selected_circle) do
              begin
                 circles[multy_selected_circle[count]].x+=delta_x;
                 circles[multy_selected_circle[count]].y+=delta_y;
              end;
              for count := 0 to High(multy_selected_arcs) do
              begin
                 arcs[multy_selected_arcs[count]].x1+=delta_x;
                 arcs[multy_selected_arcs[count]].y1+=delta_y;
                 arcs[multy_selected_arcs[count]].x2+=delta_x;
                 arcs[multy_selected_arcs[count]].y2+=delta_y;
                 arcs[multy_selected_arcs[count]].l_x+=delta_x;
                 arcs[multy_selected_arcs[count]].r_x+=delta_x;
                 arcs[multy_selected_arcs[count]].t_y+=delta_y;
                 arcs[multy_selected_arcs[count]].b_y+=delta_y;
              end;
              for count := 0 to High(multy_selected_point) do
              begin
                 points[multy_selected_point[count]].x+=delta_x;
                 points[multy_selected_point[count]].y+=delta_y;
              end;
              for count := 0 to High(multy_selected_text) do
              begin
                 nadp[multy_selected_text[count]].x+=delta_x;
                 nadp[multy_selected_text[count]].y+=delta_y;
              end;
              for count := 0 to High(multy_selected_arrow) do
              begin
                 arrow[multy_selected_arrow[count]].x+=delta_x;
                 arrow[multy_selected_arrow[count]].y+=delta_y;
              end;

              SetLength(multy_selected_line,0);
              SetLength(multy_selected_circle,0);
              SetLength(multy_selected_arcs,0);
              SetLength(multy_selected_point,0);
              SetLength(multy_selected_text,0);
              SetLength(multy_selected_arrow,0);

              stad_copy:=false;
              select_type:=0;
              selected:=10000;
              cut_mode:=false;

              clear;
              exit;
           end;

           //Единичный выбор////////////////////////////////////////
           if (select_type = 1) then //Линия
           begin
               Lines[selected].x1+=delta_x;
               Lines[selected].x2+=delta_x;
               Lines[selected].y1+=delta_y;
               Lines[selected].y2+=delta_y;

               Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
               stad_copy:=false;
               select_type:=0;
               selected:=10000;
               cut_mode:=false;
               Clear();
           end;

           if (select_type = 2) then //Окружность
           begin
               Circles[selected].x+=delta_x;
               Circles[selected].y+=delta_y;

               Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
               stad_copy:=false;
               select_type:=0;
               selected:=10000;
               cut_mode:=false;
               Clear();
           end;

           if (select_type = 3) then //Точка
           begin
               Points[selected].x+=delta_x;
               Points[selected].y+=delta_y;

               Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
               stad_copy:=false;
               select_type:=0;
               selected:=10000;
               cut_mode:=false;
               Clear();
           end;

           if (select_type = 4) then //Текст
           begin
               nadp[selected].x+=delta_x;
               nadp[selected].y+=delta_y;

               Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
               stad_copy:=false;
               select_type:=0;
               selected:=10000;
               cut_mode:=false;
               Clear();
           end;

           if (select_type = 5) then //Стрелка
           begin
               Arrow[selected].x+=delta_x;
               Arrow[selected].y+=delta_y;

               Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
               stad_copy:=false;
               select_type:=0;
               selected:=10000;
               cut_mode:=false;
               Clear();
           end;

           if (select_type = 6) then //Дуга
           begin
               Arcs[selected].x1+=delta_x;
               Arcs[selected].y1+=delta_y;
               Arcs[selected].x2+=delta_x;
               Arcs[selected].y2+=delta_y;
               Arcs[selected].r_x+=delta_x;
               Arcs[selected].l_x+=delta_x;
               Arcs[selected].t_y+=delta_y;
               Arcs[selected].b_y+=delta_y;

               Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
               stad_copy:=false;
               select_type:=0;
               selected:=10000;
               cut_mode:=false;
               Clear();
           end;

       end;
   end;

  //Копировать///////////////////////////////////////////////////////////////
  if (copy_mode = true) then
     begin
         near_points(x,y,4);

         if (stad_copy = false) then
         begin
              x_copy:=x; y_copy:=y;
              stad_copy:=true;
              Form1.StatusBar1.Panels.Items[0].Text:='Куда скопировать?';
         end
         else
         begin
              delta_x:=x-x_copy;
              delta_y:=y-y_copy;

             ///Копирование
             //Мультивыбор////////////////////////////////////////////////
           if (Length(multy_selected_line)<>0) or
              (Length(multy_selected_circle)<>0) or
              (Length(multy_selected_arcs)<>0) or
              (Length(multy_selected_point)<>0) or
              (Length(multy_selected_text)<>0) or
              (Length(multy_selected_arrow)<>0) then
           begin
              for count := 0 to High(multy_selected_line) do
              begin
                 delta_x_copy:=Lines[multy_selected_line[count]].x2-Lines[multy_selected_line[count]].x1;
                 delta_y_copy:=Lines[multy_selected_line[count]].y2-Lines[multy_selected_line[count]].y1;

                 Lines[k].x1:=Lines[multy_selected_line[count]].x1+delta_x;
                 Lines[k].x2:=Lines[multy_selected_line[count]].x2+delta_x;
                 Lines[k].y1:=Lines[multy_selected_line[count]].y1+delta_y;
                 Lines[k].y2:=Lines[multy_selected_line[count]].y2+delta_y;
                 Lines[k].col:=Lines[multy_selected_line[count]].col;
                 Lines[k].Width:=Lines[multy_selected_line[count]].width;
                 Lines[k].style:=Lines[multy_selected_line[count]].style;
                 k+=1;
              end;
              for count := 0 to High(multy_selected_circle) do
              begin
                 Circles[k_cir].x:=Circles[multy_selected_circle[count]].x+delta_x;
                 Circles[k_cir].y:=Circles[multy_selected_circle[count]].y+delta_y;
                 Circles[k_cir].r:=Circles[multy_selected_circle[count]].r;
                 Circles[k_cir].col:=Circles[multy_selected_circle[count]].col;
                 Circles[k_cir].width:=Circles[multy_selected_circle[count]].width;
                 Circles[k_cir].style:=Circles[multy_selected_circle[count]].style;
                 k_cir+=1;
              end;
              for count := 0 to High(multy_selected_arcs) do
              begin
                 Arcs[k_arc].x1:=Arcs[multy_selected_arcs[count]].x1+delta_x;
                 Arcs[k_arc].y1:=Arcs[multy_selected_arcs[count]].y1+delta_y;
                 Arcs[k_arc].x2:=Arcs[multy_selected_arcs[count]].x2+delta_x;
                 Arcs[k_arc].y2:=Arcs[multy_selected_arcs[count]].y2+delta_y;
                 Arcs[k_arc].r_x:=Arcs[multy_selected_arcs[count]].r_x+delta_x;
                 Arcs[k_arc].t_y:=Arcs[multy_selected_arcs[count]].t_y+delta_y;
                 Arcs[k_arc].l_x:=Arcs[multy_selected_arcs[count]].l_x+delta_x;
                 Arcs[k_arc].b_y:=Arcs[multy_selected_arcs[count]].b_y+delta_y;
                 Arcs[k_arc].col:=Arcs[multy_selected_arcs[count]].col;
                 Arcs[k_arc].width:=Arcs[multy_selected_arcs[count]].width;
                 Arcs[k_arc].style:=Arcs[multy_selected_arcs[count]].style;
                 k_arc+=1;
              end;
              for count := 0 to High(multy_selected_point) do
              begin
                 Points[k_points].x:=Points[multy_selected_point[count]].x+delta_x;
                 Points[k_points].y:=Points[multy_selected_point[count]].y+delta_y;
                 k_points+=1;
              end;
              for count := 0 to High(multy_selected_text) do
              begin
                 Nadp[k_nadp].x:=Nadp[multy_selected_text[count]].x+delta_x;
                 Nadp[k_nadp].y:=Nadp[multy_selected_text[count]].y+delta_y;
                 Nadp[k_nadp].h:=Nadp[multy_selected_text[count]].h;
                 Nadp[k_nadp].col:=Nadp[multy_selected_text[count]].col;
                 Nadp[k_nadp].s:=Nadp[multy_selected_text[count]].s;
                 k_nadp+=1;
              end;
              for count := 0 to High(multy_selected_arrow) do
              begin
                 Arrow[k_arrow].x:=Arrow[multy_selected_arrow[count]].x+delta_x;
                 Arrow[k_arrow].y:=Arrow[multy_selected_arrow[count]].y+delta_y;
                 Arrow[k_arrow].t:=Arrow[multy_selected_arrow[count]].t;
                 Arrow[k_arrow].col:=Arrow[multy_selected_arrow[count]].col;
                 k_arrow+=1;
              end;

              SetLength(multy_selected_line,0);
              SetLength(multy_selected_circle,0);
              SetLength(multy_selected_point,0);
              SetLength(multy_selected_text,0);
              SetLength(multy_selected_arrow,0);

              copy_mode:=false;
              stad_copy:=false;
              select_type:=0;
              selected:=10000;

              clear;
              exit;
           end;

             //Единичный выбор////////////////////////////////////////////////
             if (select_type = 1) then //Линия
             begin
                 delta_x_copy:=lines[selected].x2-lines[selected].x1;
                 delta_y_copy:=lines[selected].y2-lines[selected].y1;

                   Lines[k].x1:=lines[selected].x1+delta_x;
                   Lines[k].x2:=lines[selected].x2+delta_x;
                   Lines[k].y1:=lines[selected].y1+delta_y;
                   Lines[k].y2:=lines[selected].y2+delta_y;
                   Lines[k].col:=lines[selected].col;
                   Lines[k].width:=lines[selected].width;
                   Lines[k].style:=lines[selected].style;
                   k+=1;
             end;

             if (select_type = 2) then //Окружность
             begin
                   Circles[k_cir].x:=Circles[selected].x+delta_x;
                   Circles[k_cir].y:=Circles[selected].y+delta_y;
                   Circles[k_cir].r:=Circles[selected].r;
                   Circles[k_cir].col:=Circles[selected].col;
                   Circles[k_cir].width:=Circles[selected].width;
                   Circles[k_cir].style:=Circles[selected].style;
                   k_cir+=1;
             end;

             if (select_type = 6) then //Дуга
             begin
                   Arcs[k_arc].x1:=Arcs[selected].x1+delta_x;
                   Arcs[k_arc].y1:=Arcs[selected].y1+delta_y;
                   Arcs[k_arc].x2:=Arcs[selected].x2+delta_x;
                   Arcs[k_arc].y2:=Arcs[selected].y2+delta_y;

                   Arcs[k_arc].r_x:=Arcs[selected].r_x+delta_x;
                   Arcs[k_arc].t_y:=Arcs[selected].t_y+delta_y;
                   Arcs[k_arc].l_x:=Arcs[selected].l_x+delta_x;
                   Arcs[k_arc].b_y:=Arcs[selected].b_y+delta_y;

                   Arcs[k_arc].col:=Arcs[selected].col;
                   Arcs[k_arc].width:=Arcs[selected].width;
                   Arcs[k_arc].style:=Arcs[selected].style;
                   k_arc+=1;
             end;

             if (select_type = 3) then //Точка
             begin
                   Points[k_points].x:=Points[selected].x+delta_x;
                   Points[k_points].y:=Points[selected].y+delta_y;
                   k_points+=1;
             end;

             if (select_type = 4) then //Текст
             begin
                   Nadp[k_nadp].x:=Nadp[selected].x+delta_x;
                   Nadp[k_nadp].y:=Nadp[selected].y+delta_y;
                   Nadp[k_nadp].h:=Nadp[selected].h;
                   Nadp[k_nadp].col:=Nadp[selected].col;
                   Nadp[k_nadp].s:=Nadp[selected].s;
                   k_nadp+=1;
             end;

             if (select_type = 5) then //Стрелка
             begin
                   Arrow[k_arrow].x:=Arrow[selected].x+delta_x;
                   Arrow[k_arrow].y:=Arrow[selected].y+delta_y;
                   Arrow[k_arrow].t:=Arrow[selected].t;
                   Arrow[k_arrow].col:=Arrow[selected].col;
                   k_arrow+=1;
             end;

             Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
             stad_copy:=false;
             select_type:=0;
             selected:=10000;
             Copy_mode:=false;
             Clear();
             end;
         end;

  //Добавить стрелку//////////////////////////////////////////////////////////
  if (draw_arrow_mode = true) and not (Select_mode) then
  begin
      save_prev(); //Сохранить предыдущее состояние

      arrow[k_arrow].t:=arrow_kind;
      arrow[k_arrow].x:=x;
      arrow[k_arrow].y:=y;
      arrow[k_arrow].col:=Cvet;
      k_arrow+=1;
      clear();
  end;

  //Измерить//////////////////////////////////////////////////////////////////
  If (Get_dim_mode = true) and not (Select_mode) then
  begin
       GetLength(x,y);
   end;
end;

procedure TForm1.WSMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
  );

var
  count:integer;
  angle_vrem : real;
  rad : integer;
  Center : TPoint;
  delta_x, delta_y : integer;

begin
  X := X-Screen_x;
  Y := Y-Screen_y;

  near_points(x,y,4);

  If (((cut_mode) or (copy_mode)) and
     (stad_copy) and
     ((Length(multy_selected_line)<>0) or
     (Length(multy_selected_circle)<>0) or
     (Length(multy_selected_arcs)<>0) or
     (Length(multy_selected_point)<>0) or
     (Length(multy_selected_text)<>0) or
     (Length(multy_selected_arrow)<>0)))
     or
     (((selected<>10000) and ((cut_mode) or (copy_mode))) and (stad_copy))
     then
     begin
        WS.Canvas.Draw(0,0,imgTemp);

        delta_x:=X-x_copy;
        delta_y:=Y-y_copy;

        DrawMoved(delta_x,delta_y);
     end;

  if (FrameSelect_mode) then
   begin
     if (point1.X <> -1) and
        (point1.Y <> -1) then
         begin
            WS.Canvas.Draw(0,0,imgTemp);

            WS.Canvas.Brush.Style := bsClear;
            WS.Canvas.Pen.Color := clRed;
            WS.Canvas.Rectangle(point1.X + Screen_x,point1.Y + Screen_y,X + Screen_x,Y + Screen_y);
         end;
   end;

  If (draw_circle2point_mode) and
     (stad_cir) then
  begin
     //clear;

     WS.Canvas.Draw(0,0,imgTemp);

     center.X := Round(abs(Point1.X+X) div 2);
     center.Y := Round(abs(Point1.Y+Y) div 2);
     rad := Round(sqrt(sqr(Point1.X-X)+sqr(Point1.Y-Y)));

     WS.Canvas.Brush.Style := bsClear;
     WS.Canvas.Ellipse(center.X-(rad div 2)+screen_x,center.Y-(rad div 2)+screen_y,center.X+(rad div 2)+screen_x,center.Y+(rad div 2)+screen_y);

     Form1.WS.Canvas.TextOut(x+10+Screen_x,y-10+Screen_y,'R = '+IntToStr(rad));
  end;

  If (draw_rectangle_mode) and
     (stad) then
     begin
        //clear;

        WS.Canvas.Draw(0,0,imgTemp);

        WS.Canvas.line(x_rect+screen_x,y_rect+screen_y,x+screen_x,y_rect+screen_y);
        WS.Canvas.line(x+screen_x,y_rect+screen_y,x+screen_x,y+screen_y);
        WS.Canvas.line(x+screen_x,y+screen_y,x_rect+screen_x,y+screen_y);
        WS.Canvas.line(x_rect+screen_x,y+screen_y,x_rect+screen_x,y_rect+screen_y);

        Form1.WS.Canvas.TextOut(x+10+Screen_x,y-10+Screen_y,'B = '+IntToStr(abs(x_rect-x))+
                                                            '; H = '+IntToStr(abs(y_rect-y)));
     end;

  If (draw_circle_mode) and
     (stad_cir) then
     begin
        //clear;

        WS.Canvas.Draw(0,0,imgTemp);

        rad := Round(sqrt(power(circles[k_cir].x-x,2)+power(circles[k_cir].y-y,2)));

        WS.Canvas.Brush.Style := bsClear;
        WS.Canvas.Ellipse(circles[k_cir].x-rad+screen_x,circles[k_cir].y-rad+screen_y,
                                  circles[k_cir].x+rad+screen_x,circles[k_cir].y+rad+screen_y);

        Form1.WS.Canvas.TextOut(x+10+Screen_x,y-10+Screen_y,'R = '+IntToStr(rad));
     end;

  //Отрисовка шаблона линии на экране
  If (draw_line_mode) and  //Рисование линии
     (stad) then
     begin
        //clear;

        WS.Canvas.Draw(0,0,imgTemp);

         //if (lines[k].x1<>x) then
         //   angle_vrem :=  ArcTan(abs(lines[k].y1-y)/abs(lines[k].x1-x))
         // else
         //   angle_vrem:=DegToRad(90);
         //
         // angle_vrem := RadToDeg(angle_vrem);
         //
         //if ((x>lines[k].x1) and
         //   (y>lines[k].y1)) or
         //   ((lines[k].x1>x) and
         //   (lines[k].y1>y))
         //   then angle_vrem := -angle_vrem;

        if (lines[k].x1<x) and
           (lines[k].y1>y) then
            angle_vrem :=  ArcTan(abs(lines[k].y1-y)/abs(lines[k].x1-x))
        else
        if (lines[k].x1 = x) and
           (lines[k].y1>y) then angle_vrem:=DegToRad(90)
        else
        if (lines[k].x1>x) and
           (lines[k].y1>y) then
            angle_vrem :=  abs(ArcTan((y-lines[k].y1)/(x-lines[k].x1))-
                           DegToRad(90-ArcTan((y-lines[k].y1)/(x-lines[k].x1)))) +
                           DegToRad(90)
        else
        if (lines[k].x1>x) and
           (lines[k].y1=y) then angle_vrem :=  DegToRad(180)
        else
        if (lines[k].x1>x) and
           (lines[k].y1<y) then
            angle_vrem :=  abs(ArcTan((y-lines[k].y1)/(x-lines[k].x1))-
                           DegToRad(90-ArcTan((y-lines[k].y1)/(x-lines[k].x1)))) +
                           DegToRad(90)
        else
        if (lines[k].x1 = x) and
           (lines[k].y1<y) then angle_vrem:=DegToRad(270)
        else
        if (lines[k].x1<x) and
           (lines[k].y1<y) then
            angle_vrem :=  abs(ArcTan((y-lines[k].y1)/(x-lines[k].x1))-
                           DegToRad(90-ArcTan((y-lines[k].y1)/(x-lines[k].x1)))) +
                           DegToRad(270);


        angle_vrem := RadToDeg(angle_vrem);


        //if angle_vrem<0 then angle_vrem:=360-abs(angle_vrem);

        angle_vrem := SimpleRoundTo(angle_vrem,-3);

        WS.Canvas.Line(Lines[k].x1+Screen_x,Lines[k].y1+Screen_y,x+Screen_x,y+Screen_y);

        //Индикатор рядом с указателем мыши
        Form1.WS.Canvas.TextOut(x+10+Screen_x,y-10+Screen_y,'Угол = '+FloatToStr(angle_vrem)+
                                  ' / Длина = ' +
                                  SimpleRoundTo(sqrt(power(lines[k].x1-x,2) +
                                        power(lines[k].y1-y,2)),-2).ToString);
        exit;
     end;

  If (draw_line_mode) and //Рисование следующей точки линии
     ((last_point.x<>-1) and
     (last_point.y<>-1))
     then
        begin
          // clear;
          WS.Canvas.Draw(0,0,imgTemp);

          // if (x<>last_point.x) then
          //    angle_vrem :=  ArcTan(abs(y-last_point.y)/abs(x-last_point.x))
          // else
          //     angle_vrem:=DegToRad(90);
          //
          // angle_vrem := RadToDeg(angle_vrem);
          //
          //if ((last_point.x>x) and
          //   (last_point.y>y)) or
          //   ((x>last_point.x) and
          //   (y>last_point.y)) then
          //angle_vrem := -angle_vrem;

          if (last_point.x<x) and
             (last_point.y>y) then
             angle_vrem :=  ArcTan(abs(last_point.y-y)/abs(last_point.x-x))
          else
          if (last_point.x = x) and
             (last_point.y>y) then angle_vrem:=DegToRad(90)
          else
          if (last_point.x>x) and
             (last_point.y>y) then
              angle_vrem :=  abs(ArcTan((y-last_point.y)/(x-last_point.x))-
                             DegToRad(90-ArcTan((y-last_point.y)/(x-last_point.x)))) +
                             DegToRad(90)
          else
          if (last_point.x>x) and
             (last_point.y=y) then angle_vrem :=  DegToRad(180)
          else
          if (last_point.x>x) and
             (last_point.y<y) then
              angle_vrem :=  abs(ArcTan((y-last_point.y)/(x-last_point.x))-
                             DegToRad(90-ArcTan((y-last_point.y)/(x-last_point.x)))) +
                             DegToRad(90)
          else
          if (last_point.x = x) and
             (last_point.y<y) then angle_vrem:=DegToRad(270)
          else
          if (last_point.x<x) and
             (last_point.y<y) then
              angle_vrem :=  abs(ArcTan((y-last_point.y)/(x-last_point.x))-
                             DegToRad(90-ArcTan((y-last_point.y)/(x-last_point.x)))) +
                             DegToRad(270);


          angle_vrem := RadToDeg(angle_vrem);


          //if angle_vrem<0 then angle_vrem:=360-abs(angle_vrem);

          angle_vrem := SimpleRoundTo(angle_vrem,-3);

          WS.Canvas.Line(last_point.x+Screen_x,last_point.y+Screen_y,x+Screen_x,y+Screen_y);
          //Индикатор рядом с указателем мыши
          Form1.WS.Canvas.TextOut(x+10+Screen_x,y-10+Screen_y,'Угол = '+FloatToStr(angle_vrem)+
                                  ' / Длина = ' +
                                  SimpleRoundTo(sqrt(power(x-last_point.x,2) +
                                        power(y-last_point.y,2)),-2).ToString);
        end;

  If (drag_point_mode) and     //Перетаскивание за точку
     (Drag_selected<>-1) then
  begin
     WS.Cursor := crHandPoint;
     near_points(x,y,4);
     If (select_type = 1) then //выбрана линия
     begin
         If (Drag_Point.x = lines[drag_selected].x1) and
            (Drag_Point.y = lines[drag_selected].y1) then
         begin
            lines[drag_selected].x1:=x;
            lines[drag_selected].y1:=y;
         end
         else
         begin
            lines[drag_selected].x2:=x;
            lines[drag_selected].y2:=y;
         end;

         Drag_Point.x := x;
         Drag_Point.y := y;

         if (lines[drag_selected].x1<>lines[drag_selected].x2) then
            angle_vrem :=  ArcTan(abs(lines[drag_selected].y1-lines[drag_selected].y2)/abs(lines[drag_selected].x1-lines[drag_selected].x2))
          else
            angle_vrem:=DegToRad(90);
          angle_vrem := RadToDeg(angle_vrem);

          if ((lines[drag_selected].x2>lines[drag_selected].x1) and
             (lines[drag_selected].y2>lines[drag_selected].y1)) or
             ((lines[drag_selected].x1>lines[drag_selected].x2) and
             (lines[drag_selected].y1>lines[drag_selected].y2))
             then angle_vrem := -angle_vrem;

         if angle_vrem<0 then angle_vrem:=360-abs(angle_vrem);

         angle_vrem := SimpleRoundTo(angle_vrem,-3);
         StatusBar1.Panels.Items[0].Text:='L='+IntToStr(Round
         (sqrt(power(lines[Drag_selected].x1-lines[Drag_selected].x2,2) +
               power(lines[Drag_selected].y1-lines[Drag_selected].y2,2)))) +
         ' : Угол = '+ FloatToStr(angle_vrem);
         Form1.StatusBar1.Panels.Items[0].Text:='Отрезок';
         StatusBar1.Panels.Items[1].Text := 'X = ' + x.ToString;
         StatusBar1.Panels.Items[2].Text := 'Y = ' + y.ToString;

         clear;
         WS.Canvas.Draw(0,0,imgTemp);
         //clear;

         //Индикатор рядом с указателем мыши
         Form1.WS.Canvas.TextOut(x+10+Screen_x,y-10+Screen_y,'Угол = '+FloatToStr(angle_vrem)+
                                ' / Длина = ' +
                                SimpleRoundTo(sqrt(power(lines[Drag_selected].x1-lines[Drag_selected].x2,2) +
                                      power(lines[Drag_selected].y1-lines[Drag_selected].y2,2)),-2).ToString);
         exit;
     end;
     If (select_type = 2) then //выбрана окружность
     begin
         //If (Drag_Point.x = circles[drag_selected].x) and
         //   (Drag_Point.y = circles[drag_selected].y) then
         //begin
         //   circles[drag_selected].x:=x;
         //   circles[drag_selected].y:=y;
         //end;

         circles[drag_selected].x:=x;
         circles[drag_selected].y:=y;

         Drag_Point.x := x;
         Drag_Point.y := y;

         Form1.StatusBar1.Panels.Items[0].Text:='Окружность';
         StatusBar1.Panels.Items[1].Text := 'X = ' + x.ToString;
         StatusBar1.Panels.Items[2].Text := 'Y = ' + y.ToString;

         clear;
         WS.Canvas.Draw(0,0,imgTemp);

         //Индикатор рядом с указателем мыши
         Form1.WS.Canvas.TextOut(x+10+Screen_x,y-10+Screen_y,'X = '+  FloatToStr(X)+
                                '/ Y = ' + FloatToStr(Y));
         exit;
     end;

  end;

  StatusBar1.Panels.Items[1].Text:='X='+IntToStr(x);
  StatusBar1.Panels.Items[2].Text:='Y='+IntToStr(y);

  //if (x>0) and (x<WS.Width) and
  //   (y>0) and (y<WS.Height) then

  //УСТАНОВКА КУРСОРА МЫШИ
  begin
      x_glob:=x; y_glob:=y;

      If (not Select_mode) and (not multy_select_mode) then
         WS.Cursor:=crDefault else
                              WS.Cursor:=crHandpoint;

      for count:=0 to Arr_length-1 do
          begin
            //Проверка по массиву линий
            if (sqrt(sqr(abs(x-Lines[count].x1))+sqr(abs(y-Lines[count].y1)))<4) then
             begin
             WS.Cursor := crCross;
             end
            else if (sqrt(sqr(abs(x-Lines[count].x2))+sqr(abs(y-Lines[count].y2)))<4) then
             begin
             WS.Cursor := crCross;
             end;

            //Проверка по массиву кругов
            //Центр
             if (sqrt(sqr(abs(x-Circles[count].x))+sqr(abs(y-Circles[count].y)))<4) then
             WS.Cursor := crCross;
             //Лев.орд.
             if (sqrt(sqr((x-Circles[count].x-Circles[count].r))+sqr(abs(y-Circles[count].y)))<4) then
             Form1.WS.Cursor := crCross;
             //Прав.орд.
             if (sqrt(sqr((x-Circles[count].x+Circles[count].r))+sqr(abs(y-Circles[count].y)))<4) then
             Form1.WS.Cursor := crCross;
             //Верх.орд.
             if (sqrt(sqr(abs(x-Circles[count].x))+sqr((y-Circles[count].y-Circles[count].r)))<4) then
             Form1.WS.Cursor := crCross;
             //Нижн.орд.
             if (sqrt(sqr(abs(x-Circles[count].x))+sqr((y-Circles[count].y+Circles[count].r)))<4) then
             Form1.WS.Cursor := crCross;

            //Проверка по массиву дуг
            if (sqrt(sqr(abs(x-Arcs[count].x1))+sqr(abs(y-Arcs[count].y1)))<4) then
             begin
             WS.Cursor := crCross;
             end;
            if (sqrt(sqr(abs(x-Arcs[count].x2))+sqr(abs(y-Arcs[count].y2)))<4) then
             begin
             WS.Cursor := crCross;
             end;

            //Проверка по массиву точек
            if (sqrt(sqr(abs(x-points[count].x))+sqr(abs(y-points[count].y)))<4) then
             begin
             WS.Cursor := crCross;
             end;
          end;
  end;

end;

procedure TForm1.WSPaint(Sender: TObject);
begin
  if start_prog = true then
   begin
      WS.Canvas.Brush.Color:=clWhite;
      WS.Canvas.FillRect(WS.Canvas.ClipRect);
      start_prog:=false;
   end;
end;

procedure TForm1.Delete_ObjClick(Sender: TObject); //Меню-удалить
begin
   Delete_Ob();
end;

procedure TForm1.DimensionClick(Sender: TObject); //Измерить
begin
    selected := 10000;

    clear();

    Reset_mode;
    get_dim_mode := true;

    Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
end;

procedure TForm1.Draw_blockClick(Sender : TObject);

var
  count : integer;
  block_vrem : array of block_type;

begin
    //Сборка временного массива блока
    //Линии
    for count := 0 to High(multy_selected_line) do
    begin
       SetLength(block_vrem, Length(block_vrem)+1);
       Block_vrem[High(Block_vrem)].kind:='ln';
       Block_vrem[High(Block_vrem)].num:=multy_selected_line[count];
    end;
    //Окружности
    for count := 0 to High(multy_selected_circle) do
    begin
       SetLength(block_vrem, Length(block_vrem)+1);
       Block_vrem[High(Block_vrem)].kind:='cr';
       Block_vrem[High(Block_vrem)].num:=multy_selected_circle[count];
    end;
    //Дуги
    for count := 0 to High(multy_selected_arcs) do
    begin
       SetLength(block_vrem, Length(block_vrem)+1);
       Block_vrem[High(Block_vrem)].kind:='ar';
       Block_vrem[High(Block_vrem)].num:=multy_selected_arcs[count];
    end;
    //Точки
    for count := 0 to High(multy_selected_point) do
    begin
       SetLength(block_vrem, Length(block_vrem)+1);
       Block_vrem[High(Block_vrem)].kind:='pt';
       Block_vrem[High(Block_vrem)].num:=multy_selected_point[count];
    end;
    //Надписи
    for count := 0 to High(multy_selected_text) do
    begin
       SetLength(block_vrem, Length(block_vrem)+1);
       Block_vrem[High(Block_vrem)].kind:='tx';
       Block_vrem[High(Block_vrem)].num:=multy_selected_text[count];
    end;
    //Стрелки
    for count := 0 to High(multy_selected_arrow) do
    begin
       SetLength(block_vrem, Length(block_vrem)+1);
       Block_vrem[High(Block_vrem)].kind:='arw';
       Block_vrem[High(Block_vrem)].num:=multy_selected_arrow[count];
    end;

    Blocks[k_blocks] := Block_vrem;
    k_blocks += 1;

    block_num := -1;

    Reset_mode;
    Clear;
end;

procedure BackStep;//Отмена последнего действия
begin
   lines:=copy(lines_vrem);
   circles:=copy(circles_vrem);
   arcs:=copy(arcs_vrem);
   points:=copy(points_vrem);
   nadp:=copy(nadp_vrem);
   arrow:=copy(arrow_vrem);

   k:=k_vrem;
   k_cir:=k_cir_vrem;
   k_arc:=k_arc_vrem;
   k_points:=k_points_vrem;
   k_nadp:=k_nadp_vrem;
   k_arrow:=k_arrow_vrem;

   clear();
end;

procedure TForm1.backClick(Sender: TObject); //Отменить действие
begin
    BackStep();
end;

procedure TForm1.Change_line_styleClick(Sender : TObject);
begin
   Line_prop.ShowModal;

   Line_prop.ComboBox1.Text:=LineWeight.ToString;

   if LineStyle = psSolid then Line_prop.ComboBox2.ItemIndex:=0;
   if LineStyle = psDash then Line_prop.ComboBox2.ItemIndex:=1;
   if LineStyle = psDot then Line_prop.ComboBox2.ItemIndex:=2;
   if LineStyle = psDashDot then Line_prop.ComboBox2.ItemIndex:=3;
   if LineStyle = psDashDotDot then Line_prop.ComboBox2.ItemIndex:=4;
end;

procedure TForm1.Circle2PointClick(Sender : TObject);
begin
    Clear;

    Reset_mode;
    draw_circle2point_mode := true;

    Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
end;

procedure TForm1.Circle_3PointsClick(Sender : TObject);
begin
    Clear;

    Reset_mode;
    draw_circle3points_mode := true;

    Form1.StatusBar1.Panels.Items[0].Text:='Выбери первую точку';
end;

procedure TForm1.Clear_podlClick(Sender: TObject); //Удалить подложку
begin
  loc:='';
  podl:=false;
  back_png.Free;
  clear();
  Clear_podl.Enabled:=false;
end;

procedure TForm1.Continius_lineClick(Sender : TObject);
begin
   if Continius_line.Checked then
      contin_line := true
   else
       contin_line := false;
end;

procedure TForm1.add_backClick(Sender: TObject); //Добавить подложку
begin
     OpenDialog1.Filter:='Растровое изображение | *.bmp; *.png';
     OpenDialog1.FileName:='';

     If OpenDialog1.Execute then
     begin
          If OpenDialog1.FileName<>'' then
          begin
              loc:=OpenDialog1.FileName;
              Back_png:=TPortableNetworkGraphic.Create;

              if ExtractFileExt(loc)='.bmp' then
              begin
                   pic:=TBitmap.Create;
                   pic.LoadFromFile(loc);

                   back_png.Assign(pic);
                   pic.Free;
              end;

              if ExtractFileExt(loc)='.png' then
              begin
                   Back_png.LoadFromFile(loc);
              end;

              Form1.WS.Canvas.draw(0,0,Back_png);

              Back_png.SaveToFile(ExtractFilePath(F_name)+
                                        ExtractFileName(F_name)+'.png');

              podl:=true;
          end;
    if podl=true then Clear_podl.Enabled:=true;
    clear();
    end;
end;

procedure TForm1.Arc_buttonClick(Sender : TObject);
begin
  StatusBar1.Panels.Items[0].Text:='Укажи первую точку дуги';

  Reset_mode;
  Draw_arc_mode := true;
end;

procedure TForm1.AreaClick(Sender : TObject);  //Рассчитать площадь
begin
  If (ShHelp.Checked) then
  ShowMessage('Необходимо последовательно указать точки контура, площадь '+
              'которого надо измерить');

  StatusBar1.Panels.Items[0].Text:='Укажи точку контура в порядке обхода';

  selected := 10000;

  Reset_mode;
  get_area_mode := true;

  SetLength(point_list,0);
end;

procedure TForm1.Arr_rightClick(Sender: TObject); //Стрелка вправо
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки стрелки';

  Reset_mode;
  draw_arrow_mode := true;

  arrow_kind:='right';//вправо
end;

procedure TForm1.Ar_downClick(Sender: TObject); //стрелка вниз
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки стрелки';

  Reset_mode;
  draw_arrow_mode := true;

  arrow_kind:='down';//вниз
end;

procedure TForm1.Ar_upClick(Sender: TObject); //Стрелка вверх
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки стрелки';

  Reset_mode;
  draw_arrow_mode := true;

  arrow_kind:='up';//вправо
end;

procedure TForm1.Copy_butClick(Sender: TObject);

var
 sel_vrem : integer;
 multy_selected_line_vrem,
 multy_selected_circle_vrem,
 multy_selected_arcs_vrem,
 multy_selected_point_vrem,
 multy_selected_text_vrem,
 multy_selected_arrow_vrem : array of integer;

begin
 If (selected<>10000) or
     (Length(multy_selected_line)<>0) or
     (Length(multy_selected_circle)<>0) or
     (Length(multy_selected_arcs)<>0) or
     (Length(multy_selected_point)<>0) or
     (Length(multy_selected_text)<>0) or
     (Length(multy_selected_arrow)<>0) then
 begin
     sel_vrem := Selected;
     multy_selected_line_vrem := copy(multy_selected_line);
     multy_selected_circle_vrem := copy(multy_selected_circle);
     multy_selected_arcs_vrem := copy(multy_selected_arcs);
     multy_selected_point_vrem := copy(multy_selected_point);
     multy_selected_text_vrem := copy(multy_selected_text);
     multy_selected_arrow_vrem := copy(multy_selected_arrow);

     Reset_mode;
     copy_mode:=true;
     Selected := sel_vrem;

     multy_selected_line := copy(multy_selected_line_vrem);
     multy_selected_circle := copy(multy_selected_circle_vrem);
     multy_selected_arcs := copy(multy_selected_arcs_vrem);
     multy_selected_point := copy(multy_selected_point_vrem);
     multy_selected_text := copy(multy_selected_text_vrem);
     multy_selected_arrow := copy(multy_selected_arrow_vrem);

     Form1.StatusBar1.Panels.Items[0].Text:='Укажи базовую точку';
 end;
end;

procedure TForm1.Cross_PointClick(Sender : TObject);//Точка пересечения отрезков
                                                    //или дуги
var
  k_vrem:integer;

begin
     save_prev();

     if select_type = 6 then //выбрана дуга
     begin
         circles[k_cir].x := (arcs[selected].l_x+arcs[selected].r_x) div 2;
         circles[k_cir].y := (arcs[selected].t_y+arcs[selected].b_y) div 2;
         circles[k_cir].r := abs((arcs[selected].l_x-arcs[selected].r_x) div 2);

         k_cir+=1;

         intersection_circ_line(k_cir-1);
         ////
         intersect_2_cir(Circles[k_cir-1].x, Circles[k_cir-1].y,
         Circles[k_cir-1].r);

         Delete(circles,k_cir-1,1);
         SetLength(circles, arr_length);
         k_cir-=1;

         clear;
         exit;
     end;

     If select_type = 2 then //выбрана окружность
     begin
         intersection_circ_line(selected);
         intersect_2_cir(Circles[selected].x, Circles[selected].y,
         Circles[selected].r);

         clear;
         exit;
     end;

     If select_type = 1 then //выбрана линия
     begin
          sel_2 := Selected;

          k_vrem:=k;
          k := sel_2;
          prov_intersect();
          intersection_line_circ(k);

          k:=k_vrem;
     end;
end;

procedure TForm1.Cut_butClick(Sender: TObject);

var
  sel_vrem : integer;
  multy_selected_line_vrem,
  multy_selected_circle_vrem,
  multy_selected_arcs_vrem,
  multy_selected_point_vrem,
  multy_selected_text_vrem,
  multy_selected_arrow_vrem : array of integer;

begin
  If (selected<>10000) or
     (Length(multy_selected_line)<>0) or
     (Length(multy_selected_circle)<>0) or
     (Length(multy_selected_arcs)<>0) or
     (Length(multy_selected_point)<>0) or
     (Length(multy_selected_text)<>0) or
     (Length(multy_selected_arrow)<>0) then
  begin
      sel_vrem := Selected;
      multy_selected_line_vrem := copy(multy_selected_line);
      multy_selected_circle_vrem := copy(multy_selected_circle);
      multy_selected_arcs_vrem := copy(multy_selected_arcs);
      multy_selected_point_vrem := copy(multy_selected_point);
      multy_selected_text_vrem := copy(multy_selected_text);
      multy_selected_arrow_vrem := copy(multy_selected_arrow);

      Reset_mode;
      cut_mode:=true;
      Selected := sel_vrem;

      multy_selected_line := copy(multy_selected_line_vrem);
      multy_selected_circle := copy(multy_selected_circle_vrem);
      multy_selected_arcs := copy(multy_selected_arcs_vrem);
      multy_selected_point := copy(multy_selected_point_vrem);
      multy_selected_text := copy(multy_selected_text_vrem);
      multy_selected_arrow := copy(multy_selected_arrow_vrem);

      Form1.StatusBar1.Panels.Items[0].Text:='Укажи базовую точку';
  end;
end;

procedure TForm1.Dr_line_coordClick(Sender: TObject); //Постр.линию по коорд.
begin
  Form3.x1.Text:='';
  Form3.y1.Text:='';
  Form3.x2.Text:='';
  Form3.y2.Text:='';
  Form3.x2.Visible:=true;
  Form3.y2.Visible:=true;
  Form3.label3.Visible:=true;
  Form3.label4.Visible:=true;

  Form3.ShowModal;

  Clear();
end;

procedure TForm1.Dr_RectClick(Sender: TObject); //Меню построить прямоугольник
begin
  Clear();

  Reset_mode;
  draw_rectangle_mode := true;

  Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );

var
   d:integer = 1;

begin
 if ((Length(multy_selected_line) > 0) or
    (Length(multy_selected_circle) > 0) or
    (Length(multy_selected_arcs) > 0) or
    (Length(multy_selected_point) > 0) or
    (Length(multy_selected_text) > 0) or
    (Length(multy_selected_arrow) > 0))
    and
    (Key = VK_S)
    then SaveToBuf();

 If (Key = VK_DELETE) then Delete_Ob;//удалить

 If (Key = VK_ESCAPE) then //Отменить операцию
 begin
    BreakOperation;
 end;

  If (Key = VK_Z) and  //Отмена последней операции
     (Shift = [ssCtrl]) then  BackStep();

  if ssShift in Shift then d:=10 else d:=1;

  If (Key = VK_RIGHT) then Move_vect(d,0);//вправо
  If (Key = VK_LEFT) then Move_vect(-d,0);//влево
  If (Key = vk_up) then Move_vect(0,-d);//вверх
  If (Key = VK_DOWN) then Move_vect(0,d);//вниз

  If ((Key=Ord('v')) or (Key=Ord('V'))) and //Загрузка подложки из буфера
     (ssCtrl in Shift) then
     begin
          if (f_name='')then
             begin
                showmessage('Чертеж не сохранен');
                exit;
             end;

          if Clipboard.HasFormat(CF_BITMAP) then
          begin
              pic:=TBitmap.Create;
              pic.LoadFromClipboardFormat(CF_BITMAP);

              pic.Canvas.StretchDraw(Rect(0,0,1200,900),pic);
              pic.Width:=1200;
              pic.Height:=900;


              back_png:=TPortableNetworkGraphic.Create;
              back_png.Assign(pic);

              back_png.SaveToFile(ExtractFilePath(F_name)+
                                            ExtractFileName(F_name)+'.png');
              loc:=ExtractFilePath(F_name)+ExtractFileName(F_name)+'.png';

              podl:=true;
              Clear_podl.Enabled:=true;

              Form1.WS.Canvas.draw(0,0,back_png);
           end;
          clear;
     end;
  If (((Key >= VK_0) and (Key<=VK_9)) or //Линия по углу и длине
  ((Key >= VK_NUMPAD0) and (Key <= VK_NUMPAD9))) and (stad=true) then
  begin
      If ((Key >= VK_0) and (Key<=VK_9)) then d_length:=(StrToInt(chr(Key)));
      If (Key >= VK_NUMPAD0) then d_length:=0;
      If (Key >= VK_NUMPAD1) then d_length:=1;
      If (Key >= VK_NUMPAD2) then d_length:=2;
      If (Key >= VK_NUMPAD3) then d_length:=3;
      If (Key >= VK_NUMPAD4) then d_length:=4;
      If (Key >= VK_NUMPAD5) then d_length:=5;
      If (Key >= VK_NUMPAD6) then d_length:=6;
      If (Key >= VK_NUMPAD7) then d_length:=7;
      If (Key >= VK_NUMPAD8) then d_length:=8;
      If (Key >= VK_NUMPAD9) then d_length:=9;
      //Showmessage(IntToStr(d_length));

      Near_points(x_glob,y_glob,4);

      if draw_line_mode then
      begin
          Form6.Dlina.Text:=IntToStr(d_length);
          Form6.Label1.Caption:='Угол пр. час.стр.';
          Form6.Label2.Caption:='Длина';
          Form6.ShowModal;
          Stad:=false; //вернуться к первой точке
          d_length:=0;
      end;
      if draw_rectangle_mode then
      begin
          //Form6.Dlina.Text:=IntToStr(d_length);
          Form6.Label1.Caption:='Ширина';
          Form6.Label2.Caption:='Высота';
          Form6.ShowModal;
          Stad:=false; //вернуться к первой точке
          d_length:=0;
      end;
      clear;
  end;

  If (((Key >= VK_0) and (Key<=VK_9)) or //Окружность по радиусу
  ((Key >= VK_NUMPAD0) and (Key <= VK_NUMPAD9))) and (stad_cir=true) then
  begin
      If ((Key >= VK_0) and (Key<=VK_9)) then d_length:=(StrToInt(chr(Key)));
      If (Key >= VK_NUMPAD0) then d_length:=0;
      If (Key >= VK_NUMPAD1) then d_length:=1;
      If (Key >= VK_NUMPAD2) then d_length:=2;
      If (Key >= VK_NUMPAD3) then d_length:=3;
      If (Key >= VK_NUMPAD4) then d_length:=4;
      If (Key >= VK_NUMPAD5) then d_length:=5;
      If (Key >= VK_NUMPAD6) then d_length:=6;
      If (Key >= VK_NUMPAD7) then d_length:=7;
      If (Key >= VK_NUMPAD8) then d_length:=8;
      If (Key >= VK_NUMPAD9) then d_length:=9;


      Circles[k_cir].r := StrToInt(Inputbox('Графика',
                                   'Введи радиус',IntToStr(d_length)));
      if Circles[k_cir].r<>0 then
      begin
          Circles[k_cir].col:=Cvet;

          //Отрисовка ординат
          //1
          points[k_points].x:=Circles[k_cir].x;
          points[k_points].y:=Circles[k_cir].y-Circles[k_cir].r;
          //2
          points[k_points+1].x:=Circles[k_cir].x;
          points[k_points+1].y:=Circles[k_cir].y+Circles[k_cir].r;
          //3
          points[k_points+2].x:=Circles[k_cir].x-Circles[k_cir].r;
          points[k_points+2].y:=Circles[k_cir].y;
          //4
          points[k_points+3].x:=Circles[k_cir].x+Circles[k_cir].r;
          points[k_points+3].y:=Circles[k_cir].y;
          //Центр
          points[k_points+4].x:=Circles[k_cir].x;
          points[k_points+4].y:=Circles[k_cir].y;

          k_points+=5;
          k_cir+=1;

          ////
          intersection_circ_line(k_cir-1);
          ////
          Clear();
      end

      else
      begin
          Delete(Circles,selected,1);
          SetLength(Circles,arr_length);
          Clear();//Очистка формы
      end;
      stad_cir:=false;
      //Clear();//Очистка формы
  end;
 end;


procedure TForm1.FormWindowStateChange(Sender : TObject);
begin
  Start_timer_delay.Enabled:=true;
end;

procedure TForm1.Get_AngleClick(Sender : TObject);
begin
   selected := 10000;

   Clear;

   Reset_mode;

   get_angle_mode := true;
   Form1.StatusBar1.Panels.Items[0].Text:='Укажи послед. точки пересек. отрезков';
end;

procedure TForm1.Get_Centr_MassClick(Sender : TObject);
begin
  selected := 10000;

  Clear;
  Reset_mode;
  get_centr_mass_mode := true;

  Form1.StatusBar1.Panels.Items[0].Text:='Укажи внутр. точку контура';
end;

 procedure TForm1.AllKrugClick(Sender: TObject);//Чертить окружность
begin
  Clear;

  Reset_mode;
  draw_circle_mode := true;

  Form1.StatusBar1.Panels.Items[0].Text:='Укажи центр окружности';
end;

procedure TForm1.Add_VectorClick(Sender: TObject);//Добавить вектор

var
  f_name:string = '';

begin
   save_prev(); //Сохранить предыдущее состояние

   OpenDialog1.Filter:='Файл Vector | *.vp';
   OpenDialog1.FileName:='';

   If OpenDialog1.Execute then
       f_name:=OpenDialog1.FileName;
   if f_name<>'' then  Add_vect(f_name);

   add_back.Enabled:=true;

   Clear();
end;

procedure TForm1.Div_2Click(Sender: TObject);//Точка середины отрезка
begin
     midle_point();
end;

procedure TForm1.Clear_allClick(Sender: TObject);//Кнопка удалить все
begin
   Clear_all_fig();
   Save_as_menu.Enabled:=false;
end;

procedure TForm1.OutMultiAngleClick(Sender : TObject);
begin
    Reset_mode();
    Draw_MultiAngleOutMode := true;
    Form1.StatusBar1.Panels.Items[0].Text:='Укажи центр многоугольника'
end;

procedure TForm1.L_vectorClick(Sender: TObject); //Загрузить новый вектор

var
  f_name_op:string = '';

begin
   OpenDialog1.Filter:='Файл Vector | *.vp';
   OpenDialog1.FileName:='';

   If OpenDialog1.Execute then
       f_name_op:=OpenDialog1.FileName;
   if f_name_op<>'' then Load_vect(f_name_op);

   add_back.Enabled:=true;
   if podl=true then Clear_podl.Enabled:=true;

   Save_as_menu.Enabled:=true;
end;

procedure TForm1.Help_butClick(Sender: TObject);//Подсказки
begin

  Showmessage('Для перемещения выделенного элемента использовать стрелки. '+
              'Без Shift = 1 px,  иначе 10 px.'+#13+
              '********************************************************'+#13+
              'Можно добавить подложку комбинацией CTRL+V из буфера обмена'+#13+
              '********************************************************'+#13+
              'Дуга, выдавлен. вверх или влево рисуется по точкам справа-налево / сврху-вниз'+#13+
              '********************************************************');
end;

procedure TForm1.Arr_leftClick(Sender: TObject);
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки стрелки';

  Reset_mode;
  draw_arrow_mode := true;

  arrow_kind:='left';//влево

end;

procedure TForm1.Draw_hor_naprClick(Sender : TObject);
begin
   Clear();

   Reset_mode;
   Hor_napr_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку';
end;

procedure TForm1.Break_blockClick(Sender : TObject);
begin
   delete(blocks, block_num,1);
   setlength(blocks,arr_length,1000);
   block_num := -1;
end;

procedure TForm1.FrameSelectClick(Sender : TObject);
begin
   Reset_mode;
   FrameSelect_mode := true;
   Selected := 10000;



   If FrameSelect_mode = true then
             Form1.StatusBar1.Panels.Items[0].Text:='Укажи угол рамки'
   Else Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
end;

procedure TForm1.CopyToRastrBufferClick(Sender : TObject);
begin
   if ((Length(multy_selected_line) > 0) or
    (Length(multy_selected_circle) > 0) or
    (Length(multy_selected_arcs) > 0) or
    (Length(multy_selected_point) > 0) or
    (Length(multy_selected_text) > 0) or
    (Length(multy_selected_arrow) > 0))
    then SaveToBuf();
end;

procedure TForm1.Multy_Select_butttonClick(Sender : TObject);
begin
  Clear;
  Reset_mode;

  Multy_select_mode := true;

  If Multy_select_mode = true then
         Form1.StatusBar1.Panels.Items[0].Text:='Выбери объекты'
end;

procedure TForm1.InMultiAngleClick(Sender : TObject);
begin
  Reset_mode();
  Draw_MultiAngleMode := true;
  Form1.StatusBar1.Panels.Items[0].Text:='Укажи центр многоугольника'
end;


procedure TForm1.Paral_naprClick(Sender : TObject);

var
  sel_vrem : integer;

begin
   Clear();

   sel_vrem := Selected;
   Reset_mode;
   Selected := Sel_vrem;

   if (selected<>10000) and
      (select_type = 1) then      //Выбрана линия
   begin
     par_shift_mode:=true;
     Form1.StatusBar1.Panels.Items[0].Text:='Укажи смещение';
   end;
end;

procedure TForm1.PerimetrClick(Sender : TObject); //Измерить периметр контура
begin
  selected := 10000;

  Clear;
  Reset_mode;
  get_perimetr_mode := true;

  StatusBar1.Panels.Items[0].Text:='Укажи точку внутри контура';
end;

procedure TForm1.Save_as_menuClick(Sender : TObject);
begin
     SaveDialog1.Filter:='Векторное изображение | *.vp';
     SaveDialog1.FileName:='';

     If SaveDialog1.Execute then
          f_name:=SaveDialog1.FileName;
     if f_name<>'' then Save_vect(f_name);
end;

procedure TForm1.Scroll_hChange(Sender : TObject);
begin
  ///Start_timer_delay.Enabled:=true;
  Screen_x := -Scroll_h.Position;
  //WS.Left := -Scroll_h.Position;
  //Showmessage(WS.Left.ToString);
  clear;
end;

procedure TForm1.Scroll_vChange(Sender : TObject);
begin
  //Start_timer_delay.Enabled:=true;
  Screen_y := -Scroll_v.Position;
  //WS.Top := -Scroll_v.Position;
  //Showmessage(WS.Left.ToString);
  clear;
end;

procedure TForm1.Shift_XClick(Sender : TObject);

var
  Sdvig_txt: string;
  Sdvig : integer;
  k_vrem : integer;
  count : integer;

begin
  if (Length(multy_selected_line)<>0) or
  (Length(multy_selected_circle)<>0) or
  (Length(multy_selected_point)<>0) or
  (Length(multy_selected_text)<>0) or
  (Length(multy_selected_arrow)<>0) then
  begin
     Sdvig_txt := InputBox('Смещение', 'Укажи смещение по X', '');
     if Sdvig_txt='' then exit;
     Sdvig := Round(StrToFloat(Sdvig_txt));

     for count:=0 to Length(multy_selected_line)-1 do
     begin
        Lines[multy_selected_line[count]].x1+=Sdvig;
        Lines[multy_selected_line[count]].x2+=Sdvig;

        k_vrem:=k;
        k := multy_selected_line[count];
        prov_intersect();
        intersection_line_circ(k);
        k:=k_vrem;
     end;
     for count:=0 to Length(multy_selected_circle)-1 do
     begin
        Circles[multy_selected_circle[count]].x+=Sdvig;

        k_vrem:=k_cir;
        k_cir := multy_selected_circle[count];
        intersection_circ_line(k_cir);
        k_cir:=k_vrem;
     end;
     for count:=0 to Length(multy_selected_arcs)-1 do
     begin
        Arcs[multy_selected_arcs[count]].x1+=Sdvig;
        Arcs[multy_selected_arcs[count]].x2+=Sdvig;
        Arcs[multy_selected_arcs[count]].l_x+=Sdvig;
        Arcs[multy_selected_arcs[count]].r_x+=Sdvig;

        //k_vrem:=k_arc;
        //k_arc := multy_selected_arc[count];
        //intersection_circ_line(k_cir);
        //k_cir:=k_vrem;
     end;
     for count:=0 to Length(multy_selected_point)-1 do
     begin
        points[multy_selected_point[count]].x+=Sdvig;
     end;
     for count:=0 to Length(multy_selected_text)-1 do
     begin
        nadp[multy_selected_text[count]].x+=Sdvig;
     end;
     for count:=0 to Length(multy_selected_arrow)-1 do
     begin
        nadp[multy_selected_arrow[count]].x+=Sdvig;
     end;

     Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
     stad_copy:=false;
     select_type:=0;
     selected:=10000;
     cut_mode:=false;
     Clear();

     SetLength(multy_selected_line,0);
     SetLength(multy_selected_circle,0);
     SetLength(multy_selected_arcs,0);
     SetLength(multy_selected_point,0);
     SetLength(multy_selected_text,0);
     SetLength(multy_selected_arrow,0);

     exit;
  end;

   If selected<>10000 then
   begin
       Sdvig_txt := InputBox('Смещение', 'Укажи смещение по X', '');
       if Sdvig_txt='' then exit;
       Sdvig := Round(StrToFloat(Sdvig_txt));

                  if (select_type = 1) then //Линия
                  begin
                      Lines[selected].x1+=Sdvig;
                      Lines[selected].x2+=Sdvig;

                      k_vrem:=k;
                      k := selected;
                      prov_intersect();
                      intersection_line_circ(k);
                      k:=k_vrem;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 2) then //Окружность
                  begin
                      Circles[selected].x+=Sdvig;

                      k_vrem:=k_cir;
                      k_cir := selected;
                      intersection_circ_line(k_cir);
                      k_cir:=k_vrem;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 6) then //Arc
                  begin
                      Arcs[selected].x1+=Sdvig;
                      Arcs[selected].x2+=Sdvig;
                      Arcs[selected].l_x+=Sdvig;
                      Arcs[selected].r_x+=Sdvig;

                      //k_vrem:=k_cir;
                      //k_cir := selected;
                      //intersection_circ_line(k_cir);
                      //k_cir:=k_vrem;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 3) then //Точка
                  begin
                      Points[selected].x+=Sdvig;
                      //Points[selected].y+=delta_y;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 4) then //Текст
                  begin
                      nadp[selected].x+=Sdvig;
                      //nadp[selected].y+=delta_y;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 5) then //Стрелка
                  begin
                      Arrow[selected].x+=Sdvig;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;
   end;
end;

procedure TForm1.Shift_YClick(Sender : TObject);

var
  Sdvig_txt: string;
  Sdvig : integer;
  k_vrem : integer;
  count : integer;

begin
   if (Length(multy_selected_line)<>0) or
   (Length(multy_selected_circle)<>0) or
   (Length(multy_selected_point)<>0) or
   (Length(multy_selected_text)<>0) or
   (Length(multy_selected_arrow)<>0) then
   begin
      Sdvig_txt := InputBox('Смещение', 'Укажи смещение по Y', '');
      if Sdvig_txt='' then exit;
      Sdvig := Round(StrToFloat(Sdvig_txt));

      for count:=0 to Length(multy_selected_line)-1 do
      begin
         Lines[multy_selected_line[count]].y1+=Sdvig;
         Lines[multy_selected_line[count]].y2+=Sdvig;

         k_vrem:=k;
         k := multy_selected_line[count];
         prov_intersect();
         intersection_line_circ(k);
         k:=k_vrem;
      end;
      for count:=0 to Length(multy_selected_circle)-1 do
      begin
         Circles[multy_selected_circle[count]].y+=Sdvig;

         k_vrem:=k_cir;
         k_cir := multy_selected_circle[count];
         intersection_circ_line(k_cir);
         k_cir:=k_vrem;
      end;
      for count:=0 to Length(multy_selected_arcs)-1 do
      begin
         Arcs[multy_selected_arcs[count]].y1+=Sdvig;
         Arcs[multy_selected_arcs[count]].y2+=Sdvig;
         Arcs[multy_selected_arcs[count]].t_y+=Sdvig;
         Arcs[multy_selected_arcs[count]].b_y+=Sdvig;

         //k_vrem:=k_cir;
         //k_cir := multy_selected_circle[count];
         //intersection_circ_line(k_cir);
         //k_cir:=k_vrem;
      end;
      for count:=0 to Length(multy_selected_point)-1 do
      begin
         points[multy_selected_point[count]].y+=Sdvig;
      end;
      for count:=0 to Length(multy_selected_text)-1 do
      begin
         nadp[multy_selected_text[count]].y+=Sdvig;
      end;
      for count:=0 to Length(multy_selected_arrow)-1 do
      begin
         nadp[multy_selected_arrow[count]].y+=Sdvig;
      end;

      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
      stad_copy:=false;
      select_type:=0;
      selected:=10000;
      cut_mode:=false;
      Clear();

      SetLength(multy_selected_line,0);
      SetLength(multy_selected_circle,0);
      SetLength(multy_selected_arcs,0);
      SetLength(multy_selected_point,0);
      SetLength(multy_selected_text,0);
      SetLength(multy_selected_arrow,0);

      exit;
   end;

   If selected<>10000 then
   begin

       Sdvig_txt := InputBox('Смещение', 'Укажи смещение по Y (сверху вниз)', '');
       if Sdvig_txt='' then exit;
       Sdvig := Round(StrToFloat(Sdvig_txt));

       if (select_type = 1) then //Линия
                  begin
                      Lines[selected].y1+=Sdvig;
                      Lines[selected].y2+=Sdvig;

                      k_vrem:=k;
                      k := selected;
                      prov_intersect();
                      intersection_line_circ(k);
                      k:=k_vrem;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 2) then //Окружность
                  begin
                      Circles[selected].y+=Sdvig;

                      k_vrem:=k_cir;
                      k_cir := selected;
                      intersection_circ_line(k_cir);
                      k_cir:=k_vrem;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 6) then //Дуга
                  begin
                      Arcs[selected].y1+=Sdvig;
                      Arcs[selected].y2+=Sdvig;
                      Arcs[selected].t_y+=Sdvig;
                      Arcs[selected].b_y+=Sdvig;

                      //k_vrem:=k_cir;
                      //k_cir := selected;
                      //intersection_circ_line(k_cir);
                      //k_cir:=k_vrem;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 3) then //Точка
                  begin
                      Points[selected].y+=Sdvig;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 4) then //Текст
                  begin
                      nadp[selected].y+=Sdvig;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;

                  if (select_type = 5) then //Стрелка
                  begin
                      Arrow[selected].y+=Sdvig;

                      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
                      stad_copy:=false;
                      select_type:=0;
                      selected:=10000;
                      cut_mode:=false;
                      Clear();
                  end;
   end;
end;

procedure TForm1.Menu_AddTextClick(Sender: TObject); //Добавить текст
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки текста';
  Reset_mode;
  Text_input_mode:=true;
end;


procedure TForm1.Draw_lineClick(Sender: TObject); //Чертить линию
begin
   Clear();

   Reset_mode;
   draw_line_mode:=true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
end;

procedure TForm1.Draw_napr_2pointClick(Sender : TObject);
begin
   Clear();

   Reset_mode;
   Two_point_napr_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку';
end;

procedure TForm1.Draw_napr_angleClick(Sender : TObject);
begin
   Clear();

   Reset_mode;
   Angle_napr_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку';
end;

procedure TForm1.Draw_vert_naprClick(Sender : TObject);
begin
   Clear();

   Reset_mode;
   Vert_napr_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку';
end;

procedure TForm1.ModifyClick(Sender: TObject);//Редактировать
begin
   save_prev(); //Сохранить предыдущее состояние

   If select_type = 6 then exit; //Дугу нельзя изменить в этом меню

   If selected<>10000 then Form2.ShowModal;
   selected:=10000;
   Clear();
end;

procedure TForm1.One_to_TwoClick(Sender: TObject);//Разделить отрезок на 2 части

var
  x11,y11,x21,y21:integer;
  x22,y22:integer;
  col:Tcolor;

begin
  If (Selected<>10000) and (Select_type = 1) then
  begin
      save_prev(); //Сохранить предыдущее состояние

          x11:=lines[selected].x1;
          x22:=lines[selected].x2;
          y11:=lines[selected].y1;
          y22:=lines[selected].y2;
          col:=lines[selected].col;

          x21:=Round(min(x22,x11)+abs(x22-x11)/2);
          y21:=Round(min(y22,y11)+abs(y22-y11)/2);

          Delete(lines,selected,1);
          SetLength(lines,arr_length);
          k-=1;

          Lines[k].x1:=x11; Lines[k].y1:=y11;
          Lines[k].x2:=x21; Lines[k].y2:=y21;
          Lines[k].col:=col;
          k+=1;

          Lines[k].x1:=x21; Lines[k].y1:=y21;
          Lines[k].x2:=x22; Lines[k].y2:=y22;
          Lines[k].col:=col;
          k+=1;

          Points[k_points].x:=x21; Points[k_points].y:=y21;
          k_points+=1;
  clear();
  end;
end;

procedure TForm1.ORTOClick(Sender: TObject); //Ортогональный режим
begin
    Orto_graph:= not Orto_graph;
end;


procedure TForm1.PsetClick(Sender: TObject);//Построить точку

begin
  save_prev(); //Сохранить предыдущее состояние

  Form3.x1.Text:='';
  Form3.y1.Text:='';
  Form3.x2.Text:='';
  Form3.y2.Text:='';
  Form3.x2.Visible:=false;
  Form3.y2.Visible:=false;
  Form3.label3.Visible:=false;
  Form3.label4.Visible:=false;

  Form3.ShowModal;

   if (k_points>0) then    back.Enabled:=true;

  Clear();
end;

procedure TForm1.Rectangle_coordClick(Sender: TObject);//Прямоугольник по коорд.
begin
    save_prev(); //Сохранить предыдущее состояние

    Reset_mode;
    rect_mode:=true;

    Form3.x1.Text:='';
    Form3.y1.Text:='';
    Form3.x2.Text:='';
    Form3.y2.Text:='';
    Form3.x2.Visible:=true;
    Form3.y2.Visible:=true;
    Form3.label3.Visible:=true;
    Form3.label4.Visible:=true;

    Form3.ShowModal;


    Clear();

    rect_mode:=false;
end;

procedure TForm1.Re_paintClick(Sender: TObject); //Обновить изображение
begin
      Clear();
      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
end;

procedure TForm1.Rot_selClick(Sender: TObject); //Поворот фигуры (линии)
begin
     Form1.StatusBar1.Panels.Items[0].Text:='Укажи центр поворота';
     RotMode := true;
     WS.Cursor := crDefault;
     //Rotate();
end;

procedure TForm1.Save_ScriptClick(Sender: TObject); //Сохранить скрипт VBS
begin
  SaveScript();
end;

procedure TForm1.Select_colorClick(Sender: TObject);//Выбор цвета
begin
   If ColorDialog1.Execute then Cvet := ColorDialog1.Color;
end;


procedure TForm1.Show_psetClick(Sender: TObject); //Меню - Показывать точки
begin
  P_show:=not P_show;
  Clear;
end;

procedure TForm1.Size_draftClick(Sender : TObject);

var
  vrem_width, vrem_height : integer;

begin
  vrem_width := InputBox('Новый размер поля чертежа', 'Укажи ширину поля чертежа (если <=0,'+
                         #13 + 'то размер чертежа равен окна). '+
                         #13 + 'Сейчас ширина равна ' + WS.Width.ToString, WS.Width.ToString).ToInteger;
  vrem_height := InputBox('Новый размер поля чертежа', 'Укажи высоту поля чертежа (если <=0,'+
                          #13 + 'то размер чертежа равен окна).'+
                          #13 + 'Сейчас высота равна ' + WS.Height.ToString, WS.Height.ToString).ToInteger;

  if (vrem_width <= 0) or
     (vrem_height <= 0) then
     begin
        WS.Width := Panel1.Width;
        WS.Height := Panel1.Height;
     end
  else
  begin
      WS.Width := vrem_width;
      WS.Height := vrem_height;
  end;

  Scroll_h.Position := 0;
  Scroll_v.Position := 0;

  if WS.Width-Panel1.Width > 0 then
     begin
          Scroll_h.Max := WS.Width-Panel1.Width;
          Scroll_h.Enabled := true;
     end
  else
    Scroll_h.Enabled:=false;
  if WS.Height-Panel1.Height > 0 then
     begin
          Scroll_v.Max := WS.Height-Panel1.Height;
          Scroll_v.Enabled := true;
     end
  else
    Scroll_v.Enabled := false;

  Start_timer_delay.Enabled:=true;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  imgTemp := TPortableNetworkGraphic.Create;
  imgTemp.Width := WS.Width;
  imgTemp.Height := WS.Height;

  If ParamCount > 0 then
  //Showmessage(ParamStr(1));
  begin
      Load_vect(ParamStr(1));
      add_back.Enabled:=true;
      if podl=true then Clear_podl.Enabled:=true;
      Start_timer_delay.Enabled:=true;
  end;

  WS.Canvas.Brush.Style:=bsClear;

  //WS.Width := 4000;
  //WS.Height := 4000;
  //WS.Left := 0;
  //WS.Top := 0;

  Scroll_h.Max := World_size-WS.Width;
  Scroll_v.Max := World_size-WS.Height;

  WS.Width := World_size;
  WS.Height := World_size;

  SetLength(lines,arr_length);
  SetLength(Circles,arr_length);
  SetLength(arcs,arr_length);
  SetLength(points,arr_length);
  SetLength(nadp,arr_length);
  SetLength(arrow,arr_length);
  SetLength(blocks,arr_length,1000);

  last_point.X := -1;    //Точка для непрерыавного ввода линии
  last_point.Y := -1;

  Point1.X := -1;        //Точка для рисования дуг
  Point1.Y := -1;

  save_prev();
end;

procedure TForm1.Sel_allClick(Sender: TObject); //Выбрать всё
begin
  Reset_mode;
  select_mode := true; //Режим выделения по умолчанию

  Select_type:=0;

  Form5.L_sel.Checked:=true; //Выбор всех линий
  Form5.c_sel.Checked:=true; //Выбор всех окружностей
  Form5.p_sel.Checked:=true;  //Выбор всех точек
  Form5.t_sel.Checked:=true;  //Выбор всех текстов
  Form5.arr_sel.Checked:=true;  //Выбор всех стрелок
  Form5.arc_sel.Checked:=true;  //Выбор всех дуг

  Form5.ShowModal;
  Form1.StatusBar1.Panels.Items[0].Text:=
                          'Выбрано мн. элементов';
end;

procedure TForm1.Show_back_butClick(Sender: TObject);
begin
  Show_back := not Show_back;
  Clear();
end;

procedure TForm1.S_rastrClick(Sender: TObject);//Сохранить растр

var
  f_name:string = '';

begin
  SaveDialog1.Filter:='Растровое изображение | *.png';
  SaveDialog1.FileName:='';

   If SaveDialog1.Execute then
       f_name:=SaveDialog1.FileName;

  If f_name<>'' then
  begin
        save_png:=TPortableNetworkGraphic.Create;
        save_png.Height:=WS.Height;
        save_png.Width:=WS.Width;

        //save_png.Canvas.CopyRect(Rect(0,0,WS.Width,WS.Height),WS.Canvas,
        //                                           Rect(0,0,WS.Width,WS.Height));

        //Подготовка изображения
        prepare_pic(save_png);

        save_png.SaveToFile(f_name);
        save_png.Free;
  end;
end;

procedure TForm1.S_vectorClick(Sender: TObject);//Сохранить вектор
begin
  SaveDialog1.Filter:='Векторное изображение | *.vp';
  SaveDialog1.FileName:='';

  If f_name='' then
  If SaveDialog1.Execute then
       f_name:=SaveDialog1.FileName;
  if f_name<>'' then Save_vect(f_name);
  Save_as_menu.Enabled := true;
end;

procedure TForm1.Start_timer_delayTimer(Sender : TObject);
begin
  Clear;
  Start_timer_delay.Enabled:=false;
end;

procedure TForm1.ViborClick(Sender: TObject);//Меню выбора
begin
   Reset_mode;
   Select_mode := true;
   Selected := 10000;

   If Select_mode = true then
             Form1.StatusBar1.Panels.Items[0].Text:='Выбери объект'
   Else Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
end;

procedure TForm1.WSClick(Sender : TObject);
begin

end;


end.