unit Unit2;

{
    Vector graphical editor.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2023  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Buttons,
  ExtCtrls;

type

  { TForm2 }

  TForm2 = class(TForm)
    Close_button: TButton;
    ColorDialog1: TColorDialog;
    Col_but: TPanel;
    ComboBox1 : TComboBox;
    ComboBox2 : TComboBox;
    Label3 : TLabel;
    Label4 : TLabel;
    Label5 : TLabel;
    Sel_box: TComboBox;
    Edit1: TEdit;
    x1_ed: TEdit;
    y1_ed: TEdit;
    x2_ed: TEdit;
    y2_ed: TEdit;
    r_ed: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    x2_capt: TLabel;
    y2_capt: TLabel;
    R_capt: TLabel;
    procedure Close_buttonClick(Sender: TObject);
    procedure Col_butClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form2: TForm2;

  x1,y1,x2,y2,r:integer;
  New_col:TColor;


implementation
Uses Unit1;
{$R *.lfm}

{ TForm2 }

procedure TForm2.Close_buttonClick(Sender: TObject);
begin

    x1:=StrToInt(x1_ed.Text);
    y1:=StrToInt(y1_ed.Text);

    if Unit1.select_type = 1 then //редактировать линию
    begin
        x2:=StrToInt(x2_ed.Text);
        y2:=StrToInt(y2_ed.Text);
        Unit1.lines[selected].x1:=x1;
        Unit1.lines[selected].y1:=y1;
        Unit1.lines[selected].x2:=x2;
        Unit1.lines[selected].y2:=y2;
        Unit1.lines[selected].col:=New_col;

        Unit1.lines[selected].Width:=StrToInt(ComboBox1.Text);

        case Combobox2.ItemIndex of
        0: Unit1.lines[selected].style:=psSolid;
        1: Unit1.lines[selected].style:=psDash;
        2: Unit1.lines[selected].style:=psDot;
        3: Unit1.lines[selected].style:=psDashDot;
        4: Unit1.lines[selected].style:=psDashDotDot;
        end;
    end;

    if Unit1.select_type = 2 then //редактировать окружность
    begin
        r:=StrToInt(r_ed.Text);
        Unit1.circles[selected].x:=x1;
        Unit1.circles[selected].y:=y1;
        Unit1.circles[selected].r:=r;
        Unit1.circles[selected].col:=New_col;

        Unit1.circles[selected].Width:=StrToInt(ComboBox1.Text);

        case Combobox2.ItemIndex of
        0: Unit1.circles[selected].style:=psSolid;
        1: Unit1.circles[selected].style:=psDash;
        2: Unit1.circles[selected].style:=psDot;
        3: Unit1.circles[selected].style:=psDashDot;
        4: Unit1.circles[selected].style:=psDashDotDot;
        end;
    end;

    if Unit1.select_type = 3 then //редактировать точку
    begin
        Unit1.points[selected].x:=x1;
        Unit1.points[selected].y:=y1;
    end;

    if Unit1.select_type = 4 then //редактировать текст
    begin
        Unit1.nadp[selected].x:=x1;
        Unit1.nadp[selected].y:=y1;
        Unit1.nadp[selected].s:=Form2.r_ed.Text;
        Unit1.nadp[selected].h:=StrToInt(Form2.Sel_box.Text);
        Unit1.nadp[selected].col:=New_col;
    end;

    if Unit1.select_type = 5 then //редактировать стрелку
    begin
        Unit1.arrow[selected].x:=x1;
        Unit1.arrow[selected].y:=y1;
        Unit1.arrow[selected].t:=sel_box.Text;
        Unit1.arrow[selected].col:=New_col;
    end;

    Unit1.selected:=10000;

    Self.ModalResult:=mrCancel;
end;

procedure TForm2.Col_butClick(Sender: TObject);
begin
  If colordialog1.Execute then
  begin
       new_col:=ColorDialog1.Color;
       Col_but.Color:=new_col;
  end;
end;

procedure TForm2.FormShow(Sender: TObject);
begin
       if Unit1.select_type = 1 then //редактировать линию
       begin
           Form2.r_ed.Hide;//Спрятать поля радиуса
           Form2.R_capt.Hide;
           Form2.Sel_box.Hide;

           Form2.x2_capt.Show; Form2.x2_ed.Show;
           Form2.y2_capt.Show; Form2.y2_ed.Show;

           Form2.x1_ed.Text:=IntToStr(Lines[Selected].x1);
           Form2.y1_ed.Text:=IntToStr(Lines[Selected].y1);
           Form2.x2_ed.Text:=IntToStr(Lines[Selected].x2);
           Form2.y2_ed.Text:=IntToStr(Lines[Selected].y2);

           Col_but.Color:=Lines[selected].col;
           New_col:=Lines[selected].col;

           ComboBox1.Text:=Lines[Selected].Width.ToString;

           if Lines[Selected].style = psSolid then ComboBox2.ItemIndex:=0;
           if Lines[Selected].style = psDash then ComboBox2.ItemIndex:=1;
           if Lines[Selected].style = psDot then ComboBox2.ItemIndex:=2;
           if Lines[Selected].style = psDashDot then ComboBox2.ItemIndex:=3;
           if Lines[Selected].style = psDashDotDot then ComboBox2.ItemIndex:=4;
       end;

       if Unit1.select_type = 2 then //редактировать круг
       begin
           Form2.r_ed.NumbersOnly:=True;
           Form2.R_capt.Caption:='Радиус';
           Form2.R_capt.Show; Form2.r_ed.Show;

           Form2.x2_ed.Hide;//Спрятать поля x2
           Form2.y2_ed.Hide;//Спрятать поля y2
           Form2.x2_capt.Hide;
           Form2.y2_capt.Hide;
           Form2.Sel_box.Hide;

           Form2.x1_ed.Text:=IntToStr(Circles[Selected].x);
           Form2.y1_ed.Text:=IntToStr(Circles[Selected].y);
           Form2.r_ed.Text:=IntToStr(Circles[Selected].r);

           Col_but.Color:=Circles[selected].col;
           New_col:=Circles[selected].col;

           ComboBox1.Text:=Circles[Selected].Width.ToString;
           if Circles[Selected].style = psSolid then ComboBox2.ItemIndex:=0;
           if Circles[Selected].style = psDash then ComboBox2.ItemIndex:=1;
           if Circles[Selected].style = psDot then ComboBox2.ItemIndex:=2;
           if Circles[Selected].style = psDashDot then ComboBox2.ItemIndex:=3;
           if Circles[Selected].style = psDashDotDot then ComboBox2.ItemIndex:=4;
       end;

       if Unit1.select_type = 3 then //редактировать точку
       begin
           Form2.r_ed.Hide;//Спрятать поля радиуса
           Form2.R_capt.Hide;

           Form2.x2_ed.Hide;//Спрятать поля x2
           Form2.y2_ed.Hide;//Спрятать поля y2
           Form2.x2_capt.Hide;
           Form2.y2_capt.Hide;

           Form2.Sel_box.Hide;

           Form2.x1_ed.Text:=IntToStr(Points[Selected].x);
           Form2.y1_ed.Text:=IntToStr(Points[Selected].y);
       end;


       if Unit1.select_type = 4 then //редактировать текст
              begin
                  Form2.R_capt.Show;
                  Form2.R_capt.Caption:='Текст:';
                  Form2.r_ed.NumbersOnly:=False;
                  Form2.r_ed.Show;

                  Form2.x2_ed.Hide;//Спрятать поля x2
                  Form2.y2_ed.Hide;//Спрятать поля y2
                  Form2.x2_capt.Hide;
                  Form2.y2_capt.Hide;

                  //Form2.Sel_box.Hide;

                  Form2.Sel_box.Items.Clear;

                  Form2.Sel_box.Items.Add('10');
                  Form2.Sel_box.Items.Add('14');
                  Form2.Sel_box.Items.Add('18');
                  Form2.Sel_box.Items.Add('22');
                  Form2.Sel_box.Items.Add('26');
                  Form2.Sel_box.Items.Add('30');

                  Form2.x1_ed.Text:=IntToStr(nadp[Selected].x);
                  Form2.y1_ed.Text:=IntToStr(nadp[Selected].y);
                  Form2.r_ed.Text:=(nadp[Selected].s);
                  Form2.Sel_box.Text:=IntToStr(nadp[Selected].h);

                  Col_but.Color:=Nadp[selected].col;
                  New_col:=Nadp[selected].col;
              end;

       if Unit1.select_type = 5 then //редактировать стрелку
       begin
           Form2.r_ed.Hide;//Спрятать поля радиуса
           Form2.R_capt.Hide;

           Form2.x2_ed.Hide;//Спрятать поля x2
           Form2.y2_ed.Hide;//Спрятать поля y2
           Form2.x2_capt.Hide;
           Form2.y2_capt.Hide;

           Form2.Sel_box.Show;

           Sel_box.Items.Clear;
           Sel_box.Items.Add('left'); Sel_box.Items.Add('right');
           Sel_box.Items.Add('up'); Sel_box.Items.Add('down');

           case Arrow[Selected].t of
               'left': Sel_box.ItemIndex:=0;
               'right': Sel_box.ItemIndex:=1;
               'up': Sel_box.ItemIndex:=2;
               'down': Sel_box.ItemIndex:=3;
           end;

           Form2.x1_ed.Text:=IntToStr(Arrow[Selected].x);
           Form2.y1_ed.Text:=IntToStr(Arrow[Selected].y);

           Col_but.Color:=Arrow[selected].col;
           New_col:=Arrow[selected].col;
       end;
end;

end.