unit Unit4;

{
    Vector graphical editor.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2023  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm4 }

  TForm4 = class(TForm)
    Ok_button: TButton;
    Cancel_button: TButton;
    Text_source : TMemo;
    Text_Size: TComboBox;
    Label2: TLabel;
    Label1: TLabel;
    procedure Ok_buttonClick(Sender: TObject);
    procedure Cancel_buttonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form4: TForm4;
  x_get,y_get:integer;


implementation
uses Unit1;


{$R *.lfm}

{ TForm4 }

procedure TForm4.Ok_buttonClick(Sender: TObject);

var
  count : integer;

begin
  If (Text_source.Text<>'') then
  begin
       for count:=0 to Text_source.Lines.Count-1 do
       begin
           Unit1.nadp[k_nadp].col:=Unit1.Cvet;
           Unit1.nadp[k_nadp].x:=x_get;
           Unit1.nadp[k_nadp].y:=y_get;
           Unit1.nadp[k_nadp].h:=StrToInt(Text_Size.Text);
           Unit1.nadp[k_nadp].s:=Text_Source.Lines[count];

           k_nadp+=1;
           y_get += Round(StrToInt(Text_Size.Text) * 1.5);
       end;

       Self.ModalResult:=mrCancel
  end;
end;

procedure TForm4.Cancel_buttonClick(Sender: TObject);
begin
     Self.ModalResult:=mrCancel
end;

procedure TForm4.FormShow(Sender: TObject);
begin
  Form4.Text_source.SetFocus;
end;

end.