unit Unit5;

{
    Vector graphical editor.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2023  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm5 }

  TForm5 = class(TForm)
    Cancel_but: TButton;
    arc_sel : TCheckBox;
    Ok_but: TButton;
    c_sel: TCheckBox;
    p_sel: TCheckBox;
    t_sel: TCheckBox;
    L_sel: TCheckBox;
    arr_sel: TCheckBox;
    procedure Cancel_butClick(Sender: TObject);
    procedure Ok_butClick(Sender: TObject);
  private

  public

  end;

var
  Form5: TForm5;

implementation
uses Unit1;

{$R *.lfm}

{ TForm5 }

procedure TForm5.Cancel_butClick(Sender: TObject);//Отмена
begin
  Self.ModalResult:=mrCancel;
end;

procedure TForm5.Ok_butClick(Sender: TObject);

var
  count : integer;

begin
  //Unit1.select_type:=1000000;

  //Проверка выбора линий
  If (L_sel.Checked) then
  for count := 0 to High(lines) do
    begin
             setLength(multy_selected_line,Length(multy_selected_line)+1);
             multy_selected_line[High(multy_selected_line)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;
             Form1.WS.Canvas.Line(lines[count].x1 + Screen_x,lines[count].y1 + Screen_y,
                                  lines[count].x2 + Screen_x,lines[count].y2 + Screen_y);
    end;

   //Проверка выбора окружностей
   If (c_sel.Checked) then
   for count := 0 to High(circles) do
    begin
             setLength(multy_selected_circle,Length(multy_selected_circle)+1);
             multy_selected_circle[High(multy_selected_circle)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;
             Form1.WS.Canvas.Ellipse(circles[count].x + Screen_x - circles[count].r,
                                     circles[count].y + Screen_y - circles[count].r,
                                     circles[count].x + Screen_x + circles[count].r,
                                     circles[count].y + Screen_y + circles[count].r);
    end;

    //Проверка выбора точек
    If (p_sel.Checked) then
    for count := 0 to High(points) do
    begin
             setLength(multy_selected_point,Length(multy_selected_point)+1);
             multy_selected_point[High(multy_selected_point)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;

             Form1.WS.Canvas.Ellipse(points[count].x + Screen_x - 5,
                                     points[count].y + Screen_y - 5,
                                     points[count].x + Screen_x + 5,
                                     points[count].y + Screen_y + 5);
    end;

    //Проверка выбора текста
    If (t_sel.Checked) then
    for count := 0 to High(points) do
    begin
             setLength(multy_selected_text,Length(multy_selected_text)+1);
             multy_selected_text[High(multy_selected_text)] := count;
             Form1.WS.Canvas.Font.Color := clRed;
             Form1.WS.Canvas.Font.Size := nadp[count].h;
             Form1.WS.Canvas.TextOut(nadp[count].x + Screen_x, nadp[count].y + Screen_y,nadp[count].s);
    end;


    //Проверка выбора стрелок
    If (arr_sel.Checked) then
    for count := 0 to High(points) do
    begin
             setLength(multy_selected_arrow,Length(multy_selected_arrow)+1);
             multy_selected_arrow[High(multy_selected_arrow)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;

             Form1.WS.Canvas.Ellipse(arrow[count].x + Screen_x -5,arrow[count].y + Screen_y +5,
                                        arrow[count].x + Screen_x +5,arrow[count].y + + Screen_y -5);
             if arrow[count].t = 'left' then
                  Form1.WS.Canvas.Ellipse(arrow[count].x+30-5+Screen_x,arrow[count].y+5+Screen_y,
                                          arrow[count].x+30+5+Screen_x,arrow[count].y-5+Screen_y);
             if arrow[count].t = 'right' then
                  Form1.WS.Canvas.Ellipse(arrow[count].x-30-5+Screen_x,arrow[count].y+5+Screen_y,
                                          arrow[count].x-30+5+Screen_x,arrow[count].y-5+Screen_y);
             if arrow[count].t = 'up' then
                  Form1.WS.Canvas.Ellipse(arrow[count].x-5+Screen_x,arrow[count].y+30+5+Screen_y,
                                          arrow[count].x+5+Screen_x,arrow[count].y+30-5+Screen_y);
             if arrow[count].t = 'down' then
                  Form1.WS.Canvas.Ellipse(arrow[count].x-5+Screen_x,arrow[count].y-30+5+Screen_y,
                                              arrow[count].x+5+Screen_x,arrow[count].y-30-5+Screen_y);
    end;

    //Проверка выбора дуги
    If (arc_sel.Checked) then
    for count := 0 to High(points) do
    begin
             setLength(multy_selected_arcs,Length(multy_selected_arcs)+1);
             multy_selected_arcs[High(multy_selected_arcs)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;

             Form1.WS.canvas.Arc(Arcs[count].l_x+Screen_x,Arcs[count].t_y+Screen_y,
                             Arcs[count].r_x+Screen_x,Arcs[count].b_y+Screen_y,
                             Arcs[count].x1+Screen_x,Arcs[count].y1+Screen_y,Arcs[count].x2+Screen_x,Arcs[count].y2+Screen_y);
    end;

  //If L_sel.Checked=true then Unit1.select_type+=1; //Выбор всех линий
  //If c_sel.Checked=true then Unit1.select_type+=10; //Выбор всех окружностей
  //If p_sel.Checked=true then Unit1.select_type+=100;  //Выбор всех точек
  //If t_sel.Checked=true then Unit1.select_type+=1000; //Выбор всех текстов
  //If arr_sel.Checked=true then Unit1.select_type+=10000; //Выбор всех стрелок
  //If arc_sel.Checked=true then Unit1.select_type+=100000; //Выбор всех дуг

  Self.ModalResult:=mrCancel;
end;

end.