unit Unit6;

{
    Vector graphical editor.
    Version: 1.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2023  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm6 }

  TForm6 = class(TForm)
    Ok_button: TButton;
    Cancel_button: TButton;
    Ugol: TEdit;
    Dlina: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Ok_buttonClick(Sender: TObject);
    procedure Cancel_buttonClick(Sender: TObject);
    procedure DlinaKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form6: TForm6;

implementation
Uses Unit1, Intersection_unit, my_modify, view;
{$R *.lfm}

{ TForm6 }

var
  x1,y1,x2,y2:integer;
  angle:real;
  l:integer;

procedure TForm6.Cancel_buttonClick(Sender: TObject);
begin
  Unit1.stad:=false;
  Unit1.d_length:=0;

  Delete(lines,k,1);
  SetLength(lines,arr_length);

  Self.ModalResult:=mrCancel;
end;

//Оставлена возможность через If для других объектов
procedure dobav_lin();
begin
  If (Unit1.stad=true) and (StrToInt(Form6.Dlina.Text)>0) then //Построение линии
  begin
     angle:=StrToFloat(Form6.Ugol.Text)*PI/180;
     l:=StrToInt(Form6.Dlina.Text);

     x2:=x1+Round(l*cos(angle));
     //if y_glob<y1 then  y2:=y1-Round(l*sin(angle))
     //else y2:=y1+Round(l*sin(angle));
     y2:=y1-Round(l*sin(angle));

     Unit1.lines[k].x2:=x2;
     Unit1.lines[k].y2:=y2;
     Unit1.lines[k].col:=Unit1.Cvet;

     //проверка пересечения линий
      prov_intersect();
      //проверка пересечения с окружностью
      intersection_line_circ(k);

     k+=1;

     Form6.ModalResult:=mrCancel;
  end;
end;

procedure dobav_rect();
begin
  //1 координата

    save_prev(); //Сохранить предыдущее состояние

    lines[k].x1:=x_rect;
    lines[k].y1:=y_rect;
    lines[k].x2:=x_rect+StrToInt(Form6.Ugol.Text);
    lines[k].y2:=y_rect;
    lines[k].col:=Cvet;
    lines[k].Width:=LineWeight;
    lines[k].style:=LineStyle;
    //проверка пересечения линий
    prov_intersect();
    //проверка пересечения с окружностью
    intersection_line_circ(k);
    k+=1;

    lines[k].x1:=x_rect+StrToInt(Form6.Ugol.Text);
    lines[k].y1:=y_rect;
    lines[k].x2:=x_rect+StrToInt(Form6.Ugol.Text);
    lines[k].y2:=y_rect+StrToInt(Form6.Dlina.Text);
    lines[k].col:=Cvet;
    lines[k].Width:=LineWeight;
    lines[k].style:=LineStyle;
    //проверка пересечения линий
    prov_intersect();
    //проверка пересечения с окружностью
    intersection_line_circ(k);
    k+=1;

    lines[k].x1:=x_rect+StrToInt(Form6.Ugol.Text);
    lines[k].y1:=y_rect+StrToInt(Form6.Dlina.Text);
    lines[k].x2:=x_rect;
    lines[k].y2:=y_rect+StrToInt(Form6.Dlina.Text);
    lines[k].col:=Cvet;
    lines[k].Width:=LineWeight;
    lines[k].style:=LineStyle;
    //проверка пересечения линий
    prov_intersect();
    //проверка пересечения с окружностью
    intersection_line_circ(k);
    k+=1;

    lines[k].x1:=x_rect;
    lines[k].y1:=y_rect+StrToInt(Form6.Dlina.Text);
    lines[k].x2:=x_rect;
    lines[k].y2:=y_rect;
    lines[k].col:=Cvet;
    lines[k].Width:=LineWeight;
    lines[k].style:=LineStyle;
    //проверка пересечения линий
    prov_intersect();
    //проверка пересечения с окружностью
    intersection_line_circ(k);
    k+=1;

    stad:=false;

    Clear();//Очистка формы

    Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
    Form6.ModalResult:=mrCancel;
end;

procedure TForm6.DlinaKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  If (Key=ord(13)) and (Unit1.stad=true) then
  If draw_line_mode then
     dobav_lin()
  else
     dobav_rect();
end;

procedure TForm6.FormShow(Sender: TObject);
begin
     if draw_line_mode then
     begin
         x1:=Unit1.lines[k].x1;
         y1:=Unit1.lines[k].y1;
         If Dlina.Text<>'' then
            l:=StrToInt(Dlina.Text);

         Ugol.Text:=FloatToStr(Angle*180/pi);

         Dlina.SetFocus;
         Dlina.SelStart:=2;
     end;
     if draw_rectangle_mode then
     begin
         Ugol.Text:='';
         Dlina.Text:='';
         Dlina.SetFocus;
         Dlina.SelStart:=2;
     end;
end;

procedure TForm6.Ok_buttonClick(Sender: TObject);
begin
  if draw_line_mode then
     dobav_lin();
  if draw_Rectangle_mode then
     dobav_rect();
end;

end.